' ASYNC.BAS

' Asynchronous sockets example. This is just a simple HTTP client that grabs
' data from a HTTP server and does nothing with it.

' Include all functions defined in "wsockqb.bi"
REM $INCLUDE: 'wsockqb.bi'

CLS

' Call WSInit to set up WSOCKQB (eg. find entry points, load VxDs, WSInit
' should return 0 if everything is OK
ReturnValue% = WSInit
IF ReturnValue% = -4 THEN SHELL "WSLOADER.EXE"
t0! = TIMER
DO UNTIL ReturnValue% <> -4 OR TIMER - t0! > 5  ' Wait maximum 5 seconds
  ReturnValue% = WSInit
LOOP
PRINT "Initialising WSOCKXS..."; ReturnValue%

' If WSInit did not return 0 exit (end)
IF ReturnValue% <> 0 THEN
  PRINT "ERROR..."
  END
END IF

' Startup winsock. wsadataStruc is defined in "wsockqb.bi". On return
' wsadata's fields should be filled with stuff.
DIM SHARED wsadata AS wsadataStruc
PRINT "Starting up winsock..."; WSAStartup(&H202, wsadata)

' Input a HTTP server name from user. The program checks to see if a user
' entered an IP address. If the user did, the program simply uses that IP
' address. If it was not an IP address, the program uses "ResolveName" to
' resolve the input.
INPUT "Enter HTTP server name:"; IP$
IF inetaddr(IP$) <> INADDRNONE THEN
  IPAddr$ = inetaddr(IP$)
ELSE
  ' All the other variables are named a$, b$ etc. because we don't need them.
  ResolveName IP$, a$, b$, c%, d%, IPAddr$, 0, e&
END IF
PRINT "IP address: "; inetntoa(IPAddr$)

' Allocate message buffer and enable message handling
DIM SHARED Message AS MessageStruc
EnableMessage

NewSocket& = socket(AFINET, SOCKSTREAM, IPPROTOTCP)
PRINT "New socket: "; HEX$(NewSocket&)

PRINT "Connecting...";

DIM SHARED ConnectBuffer AS sockaddr
ConnectBuffer.sinfamily = 2
ConnectBuffer.sinport = htons(80)
ConnectBuffer.sinaddr = IPAddr$
ConnectBuffer.sinzero = STRING$(8, 0)

' One is really supposed to check for errors here but oh well...
junk& = WSAAsyncSelect(NewSocket&, GetHWnd, &H401, FDCONNECT)
junk& = connect(NewSocket&, ConnectBuffer, LEN(ConnectBuffer))

DO
  IF INKEY$ <> "" THEN GOTO closesock
LOOP UNTIL GetMessage(Message)

IF GetHigh16(Message.lParam) = 0 THEN
  PRINT "done"
ELSE
  PRINT "error:"; GetHigh16(Message.lParam)
  GOTO closesock
END IF

mybuf$ = "GET /index.html" + CHR$(13) + CHR$(10)
PRINT "BYTES SENT:"; send(NewSocket&, mybuf$, LEN(mybuf$), 0)

junk& = WSAAsyncSelect(NewSocket&, GetHWnd, &H401, FDREAD + FDCLOSE)

DIM SHARED MyRecv AS STRING * 1024

PRINT "Waiting for data..."
DO
  DO
    IF INKEY$ <> "" THEN GOTO closesock
  LOOP UNTIL GetMessage(Message)
  BytesRecv& = recv(NewSocket&, MyRecv, LEN(MyRecv), 0)
  PRINT "BYTES RECIEVED:"; BytesRecv&
LOOP UNTIL BytesRecv& = 0 OR BytesRecv& = -1
IF BytesRecv& = -1 THEN PRINT "RECV ERROR:"; WSAGetLastError

closesock:
PRINT "Closing socket..."; closesocket(NewSocket&)

PRINT "Cleaning up winsock..."; WSACleanup

DisableMessage
SelfDestruct

