' RESOLVA.BAS

' Demonstrates asynchronous name resolution. If you look at RESOLVB.BAS you
' will see asynchronous name resolution is much more complicating than
' blocking name resolution.

' Include WSOCKXS definitions
REM $INCLUDE: 'wsockqb.bi'

CLS

' Initialise WSOCKXS using WSInit()
PRINT "Initialising WSOCKXS...";
ReturnValue% = WSInit
IF ReturnValue% = -4 THEN SHELL "WSLOADER.EXE"
t0! = TIMER
DO UNTIL ReturnValue% <> -4 OR TIMER - t0! > 1  ' Wait maximum one second
  ReturnValue% = WSInit
LOOP
IF ReturnValue% <> 0 THEN
  PRINT "ERROR:"; ReturnValue%
  END
END IF
PRINT "done"

' Enable message handling
DIM SHARED Message AS MessageStruc
EnableMessage

' Startup winsock
DIM SHARED wsadata AS wsadataStruc
PRINT "WSAStartup returned:"; WSAStartup(&H101, wsadata)

' Start the name resolution
INPUT "Enter a name to resolve: "; hostname$

' Remember, AsyncResolveName only initiates the name resolution. You have
' to wait for the message for the results.
AsyncResolveName hostname$ + CHR$(0), GetHWnd, &H1001, async&, mem&, errval&

' Wait for it to complete
DO
  ' If user presses a key then abort name resolution
  IF INKEY$ <> "" THEN
    PRINT "Aborting..."
    CancelResolve async&, mem&
    GOTO AbortResolve
  END IF
LOOP UNTIL GetMessage(Message)

IF GetHigh16(Message.lParam) = 0 THEN
  ' Get the results
  ' Throw away RealName, HostAlias etc. (just call them a$, b$ and never use
  ' them)
  ProcessResolve mem&, a$, b$, c%, d%, IP$, 0
  PRINT "IP address: "; inetntoa(IP$)
ELSE
  ' An error occured
  PRINT "ERROR:"; GetHigh16(Message.lParam)
END IF

AbortResolve:
PRINT "WSACleanup returned:"; WSACleanup

DisableMessage
SelfDestruct

