' RESOLVB.BAS

' A blocking name resolver. Resolves names such as "www.yahoo.com" into IP
' addresses like "66.218.74.80".

REM $INCLUDE: 'wsockqb.bi'

CLS

ReturnValue% = WSInit

' If WSOCKXS.VXD is not loaded, run WSLOADER.EXE
IF ReturnValue% = -4 THEN SHELL "WSLOADER.EXE"
t0! = TIMER
DO UNTIL ReturnValue% <> -4 OR TIMER - t0! > 1  ' Wait maximum one second
  ReturnValue% = WSInit
LOOP

IF ReturnValue% <> 0 THEN
  PRINT "WSInit() ERROR:"; ReturnValue%
  END
END IF

PRINT "WSInit() successful"

' Enable message handling
DIM SHARED Message AS MessageStruc
EnableMessage

' Startup winsock
DIM SHARED wsadata AS wsadataStruc
ret& = WSAStartup(&H101, wsadata)
PRINT "WSAStartup() returned:"; ret&

INPUT "Enter hostname to resolve: "; hostnam$

' Check first to see if the hostname entered was an IP address. It is
' incorrect to try and resolve an IP address. Use inetaddr() to try and turn
' the hostname into an IP address. If inetaddr() returns INADDRNONE then the
' hostname really is a name, otherwise it is an IP address.
errval& = 0
IF inetaddr(hostnam$) = INADDRNONE THEN
  ' It is a name, so use ResolveName to resolve it into an IP address
  ' Remember the hostname must be a null terminated string (that's why the
  ' CHR$(0) is on the end of it)
  ResolveName hostnam$ + CHR$(0), a$, b$, c%, d%, IP$, 0, errval&
ELSE
  ' Just return the IP address as a 4 byte string
  IP$ = inetaddr(hostnam$)
END IF

IF errval& = 0 THEN
  ' No error
  ' Remember, IP$ is a 4-byte string. To convert it to "x.x.x.x" notation we
  ' need to use inetntoa().
  PRINT "IP address: "; inetntoa(IP$)
ELSE
  ' An error occurred (note that errval& is the specific error code, so we
  ' don't have to use WSAGetLastError() )
  PRINT "ERROR:"; errval&
END IF

ReturnValue& = WSACleanup
PRINT "WSACleanup() returned:"; ReturnValue&

DisableMessage
SelfDestruct

