' EXTERNALS
DECLARE FUNCTION gethostbyname& (SEG HostName AS STRING)
DECLARE FUNCTION PEEK32% (BYVAL LinearAddress AS LONG)
DECLARE FUNCTION GetHigh16% (BYVAL InLong AS LONG)
DECLARE FUNCTION GetLow16% (BYVAL InLong AS LONG)
DECLARE FUNCTION gethostname& (SEG HostName AS STRING, BYVAL length AS LONG)
DECLARE FUNCTION WSAGetLastError&
DECLARE SUB LinMemFree (BYVAL MemoryHandle AS LONG)
DECLARE SUB LinMemCopy (BYVAL LinearSource AS LONG, SEG BufferDest AS STRING)
DECLARE FUNCTION SUB32& (BYVAL Operand1 AS LONG, BYVAL Operand2 AS LONG)

' PUBLICS
DECLARE SUB MoveIntoVariable (DataOFF AS INTEGER, DataSEG AS INTEGER, Pointer AS LONG, length AS INTEGER)
DECLARE FUNCTION inetaddr$ (instring AS STRING)
DECLARE FUNCTION inetntoa$ (instring AS STRING)
DECLARE SUB ResolveName (HostName AS STRING, RealName AS STRING, HostAlias AS STRING, AddrType AS INTEGER, length AS INTEGER, IPADDR AS STRING, GetMultiple AS INTEGER, ErrorValue AS LONG)
DECLARE SUB GetMyAddr (MyName AS STRING, MyIP AS STRING)
DECLARE SUB ProcessResolve (MemHandle AS LONG, RealName AS STRING, HostAlias AS STRING, AddrType AS INTEGER, length AS INTEGER, IPADDR AS STRING, GetMultiple AS INTEGER)

SUB GetMyAddr (MyName AS STRING, MyIP AS STRING)

' Uses "gethostname" to get name, then uses "gethostbyname" with name
' as returned by "gethostname" to obtain IP address
' If an error occurs MyName will be a zero length string and MyIP
' will be a null address (0.0.0.0)

' Will only return the first IP address returned by "gethostbyname"

DIM HostName AS STRING * 255
HostName = STRING$(255, 0)

junk& = gethostname(HostName, LEN(HostName))

' Returns a string once it finds a null - CHR$(0)
TempResult$ = ""
FOR X% = 1 TO LEN(HostName)
  NextChar$ = MID$(HostName, X%, 1)
  IF NextChar$ = CHR$(0) THEN EXIT FOR
  TempResult$ = TempResult$ + NextChar$
NEXT X%

MyName = TempResult$

' Get IP address using "gethostbyname"
' All this code is copied from "ResolveName"...hehe
NameBuffer$ = TempResult$ + CHR$(0)

DIM Pointer AS LONG
Pointer = gethostbyname(NameBuffer$)
IF Pointer = -1 OR Pointer = 0 THEN
  MyIP$ = STRING$(4, 0)
  EXIT SUB
END IF

DIM hAddrList AS LONG
hAddrListPtr& = Pointer + 12
CALL MoveIntoVariable(VARPTR(hAddrList), VARSEG(hAddrList), hAddrListPtr&, 4)

IF hAddrList = 0 OR hAddrList = &HFFFFFFFF THEN
  MyIP$ = STRING$(4, 0)
  EXIT SUB
END IF
DIM AddrPointer32 AS LONG

CALL MoveIntoVariable(VARPTR(AddrPointer32), VARSEG(AddrPointer32), hAddrList, 4)
IF AddrPointer32 = 0 OR AddrPointer32 = &HFFFFFFFF THEN
  MyIP$ = STRING$(4, 0)
  EXIT SUB
END IF
IPAddressField$ = ""
FOR X% = 0 TO 3
  NextChar$ = CHR$(PEEK32%(AddrPointer32 + X%))
  IPAddressField$ = IPAddressField$ + NextChar$
NEXT X%
MyIP = IPAddressField$

END SUB

FUNCTION inetaddr$ (instring AS STRING)

' Function gets normal x.x.x.x string (ie. 192.168.0.1) and
' converts it into a 4-byte network order string
' Note that in the comments "invalid" is the same as "illegal" and
' "NULL" means a zero-length string

DIM TempString AS STRING
DIM TestString AS STRING
TestString = instring

' A legal IP address contains 4 numbers, with no number lower than
' 0 or higher than 255.
' Therefore the biggest length of a string is 15 bytes (eg. 255.255.255.255)
' and the smallest is 7 bytes (eg. 0.0.0.0) so check whether string is out
' of these boundaries
IF LEN(TestString) > 15 THEN GOTO IllegalAddress
IF LEN(TestString) < 7 THEN GOTO IllegalAddress

' There should only be 3 dots in a legal IP address. If there are any more
' or less, it is invalid.
NumberOfDots% = 0
FOR Z% = 1 TO LEN(TestString)
  c$ = MID$(TestString, Z%, 1)
  IF c$ = "." THEN NumberOfDots% = NumberOfDots% + 1
NEXT Z%
IF NumberOfDots% <> 3 THEN GOTO IllegalAddress


TempString = ""
NumLength% = 0
FOR X% = 1 TO 4
  ' Get number
  number$ = ""
  SingleNumber% = 0
  DO
    NumLength% = NumLength% + 1
    SingleNumber% = SingleNumber% + 1
   
    ' Test to see if a single number is longer than 4 bytes (you have
    ' to remember you need space for the "."
    IF SingleNumber% > 4 THEN GOTO IllegalAddress
   
    ' Test to see if we have reached the end of the input string
    ' and haven't got all the numbers yet ---> INVALID
    IF X% < 4 AND NumLength% = LEN(TestString) + 1 THEN GOTO IllegalAddress
   
    ' Test to see if we have reached the end of the input string
    ' but have got all 4 numbers ---> VALID (unless last number was NULL)
    IF X% = 4 AND NumLength% = LEN(TestString) + 1 THEN
      ' Stick a "." on the end so digit checking routines work
      number$ = number$ + "."
      EXIT DO
    END IF

    NextChar$ = MID$(TestString, NumLength%, 1)
    number$ = number$ + NextChar$
  LOOP UNTIL NextChar$ = "."
 
  ' If string is NULL or just a "." then it is invalid
  IF number$ = "" OR number$ = "." THEN GOTO IllegalAddress
 
  ' If string contains anything other than digits it is invalid
  ' To test that we see if the number of digits is equal to the
  ' length of the string
  NumberOfDigits% = 0
  FOR Y% = 1 TO LEN(number$)
    b$ = MID$(number$, Y%, 1)
    IF b$ >= "0" AND b$ <= "9" THEN NumberOfDigits% = NumberOfDigits% + 1
  NEXT Y%
  IF NumberOfDigits% = 0 THEN GOTO IllegalAddress
  IF NumberOfDigits% <> (LEN(number$) - 1) THEN GOTO IllegalAddress

  Num% = VAL(number$)
  IF Num% < 0 OR Num% > 255 THEN GOTO IllegalAddress
  TempString = TempString + CHR$(Num%)
NEXT X%

inetaddr$ = TempString

' Use EXIT FUNCTION to skip IllegalAddress
EXIT FUNCTION

IllegalAddress:
inetaddr$ = STRING$(4, 255)

END FUNCTION

FUNCTION inetntoa$ (instring AS STRING)

' This functions converts a 4-byte length string into
' it's respective IP address in x.x.x.x format. If
' the string is more or less than 4 bytes, this functions
' returns NULL (a zero-length string). If the string is 4
' bytes long, it is assumed to be valid.
' Note that unlike the winsock function, this function simply
' returns the string, not a pointer

IF LEN(instring) <> 4 THEN
  inetntoa$ = ""
  EXIT FUNCTION
END IF

DIM TempInString AS STRING
DIM TempOutString AS STRING
TempInString = instring
TempOutString = ""

FOR X% = 1 TO 4
  TempOutString = TempOutString + LTRIM$(STR$(ASC(MID$(TempInString, X%, 1))))
  TempOutString = TempOutString + "."
NEXT X%

' By now we will have an extra dot on the end. Destroy it.
inetntoa$ = LEFT$(TempOutString, LEN(TempOutString) - 1)

END FUNCTION

SUB MoveIntoVariable (DataOFF AS INTEGER, DataSEG AS INTEGER, Pointer AS LONG, length AS INTEGER)

DEF SEG = DataSEG
BaseOffset% = DataOFF
FOR X% = 0 TO (length - 1)
  POKE BaseOffset% + X%, PEEK32(Pointer + X%)
NEXT X%
DEF SEG

END SUB

SUB ProcessResolve (MemHandle AS LONG, RealName AS STRING, HostAlias AS STRING, AddrType AS INTEGER, length AS INTEGER, IPADDR AS STRING, GetMultiple AS INTEGER)

' Exactly like ResolveName, except handles a memory handle which it uses
' to copy and translate a buffer.

' Copy buffer and free memory
DIM buffer AS STRING * 1024
LinMemCopy MemHandle, buffer
LinMemFree MemHandle

DIM hName AS LONG
DIM hAlias AS LONG
DIM FirstAliasPointer32 AS LONG
DIM hAddrType AS INTEGER
DIM hLength AS INTEGER
DIM hAddrList AS LONG
DIM AddrPointer32 AS LONG

hName = CVL(MID$(buffer, 1, 4))
hAlias = CVL(MID$(buffer, 5, 4))
hAddrType = CVI(MID$(buffer, 9, 2))
hLength = CVI(MID$(buffer, 11, 2))
hAddrList = CVL(MID$(buffer, 13, 4))

' Get real name
nametemp$ = ""
X% = 0

IF hName = 0 THEN GOTO InvalidNamePointer2
hName = SUB32(hName, MemHandle) + 1
IF hName < 1 OR hName > 1024 THEN GOTO InvalidNamePointer2

DO
  NextChar$ = MID$(buffer, hName + X%, 1)
  IF NextChar$ = CHR$(0) THEN EXIT DO
  nametemp$ = nametemp$ + NextChar$
  X% = X% + 1
LOOP
InvalidNamePointer2:
RealName = nametemp$

' Get FIRST alias
aliastemp$ = ""
X% = 0

IF hAlias = 0 THEN GOTO InvalidAliasPointer2
hAlias = SUB32(hAlias, MemHandle) + 1
IF hAlias < 1 OR hAlias > 1024 THEN GOTO InvalidAliasPointer2

FirstAliasPointer32 = CVL(MID$(buffer, hAlias, 4))
IF FirstAliasPointer32 = 0 THEN GOTO InvalidAliasPointer2
FirstAliasPointer32 = SUB32(FirstAliasPointer32, MemHandle) + 1
IF FirstAliasPointer32 < 1 OR FirstAliasPointer32 > 1024 THEN GOTO InvalidAliasPointer2

DO
  NextChar$ = MID$(buffer, FirstAliasPointer32 + X%, 1)
  IF NextChar$ = CHR$(0) THEN EXIT DO
  aliastemp$ = aliastemp$ + NextChar$
  X% = X% + 1
LOOP
InvalidAliasPointer2:
HostAlias = aliastemp$

' Get address type and length
AddrType = hAddrType
length = hLength

' Get IP addresses
IPADDR = ""

IF hAddrList = 0 THEN GOTO InvalidAddrPointer2
hAddrList = SUB32(hAddrList, MemHandle) + 1
IF hAddrList < 1 OR hAddrList > 1024 THEN GOTO InvalidAddrPointer2

DO
  AddrPointer32 = CVL(MID$(buffer, hAddrList, 4))
  IF AddrPointer32 = 0 THEN GOTO InvalidAddrPointer2
  AddrPointer32 = SUB32(AddrPointer32, MemHandle) + 1
  IF AddrPointer32 < 1 OR AddrPointer32 > 1024 THEN GOTO InvalidAddrPointer2

  IPAddressField$ = MID$(buffer, AddrPointer32, 4)
  hAddrList = hAddrList + 4
  IPADDR = IPADDR + IPAddressField$
  IF GetMultiple = 0 THEN EXIT SUB
LOOP

InvalidAddrPointer2:
IPADDR = IPADDR + STRING$(4, 0)

END SUB

SUB ResolveName (HostName AS STRING, RealName AS STRING, HostAlias AS STRING, AddrType AS INTEGER, length AS INTEGER, IPADDR AS STRING, GetMultiple AS INTEGER, ErrorValue AS LONG)

' SUBroutine provides easier way to resolve hostnames
' Returns:
' Full host's name, first alias, address type, length, first IP address
' Returns NULL or zero-length string if field is empty

' If field GetMultiple is non-zero, multiple IP addresses will be
' returned. They are returned as a string split into 4-byte IP
' addresses, ending with four 0s

NameBuffer$ = HostName + CHR$(0)

DIM Pointer AS LONG
Pointer = gethostbyname(NameBuffer$)
IF Pointer = -1 OR Pointer = 0 THEN
  ErrorValue = WSAGetLastError
  EXIT SUB
END IF

DIM hName AS LONG
hNamePtr& = Pointer
DIM hAlias AS LONG
hAliasPtr& = Pointer + 4
DIM hAddrType AS INTEGER
hAddrTypePtr& = Pointer + 8
DIM hLength AS INTEGER
hLengthPtr& = Pointer + 10
DIM hAddrList AS LONG
hAddrListPtr& = Pointer + 12

CALL MoveIntoVariable(VARPTR(hName), VARSEG(hName), hNamePtr&, 4)
CALL MoveIntoVariable(VARPTR(hAlias), VARSEG(hAlias), hAliasPtr&, 4)
CALL MoveIntoVariable(VARPTR(hAddrType), VARSEG(hAddrType), hAddrTypePtr&, 2)
CALL MoveIntoVariable(VARPTR(hLength), VARSEG(hLength), hLengthPtr&, 2)
CALL MoveIntoVariable(VARPTR(hAddrList), VARSEG(hAddrList), hAddrListPtr&, 4)

' Get real name
nametemp$ = ""
X% = 0
IF hName = 0 OR hName = &HFFFFFFFF THEN GOTO InvalidNamePointer
DO
  NextChar$ = CHR$(PEEK32%(hName + X%))
  IF NextChar$ = CHR$(0) THEN EXIT DO
  nametemp$ = nametemp$ + NextChar$
  X% = X% + 1
LOOP
InvalidNamePointer:
RealName = nametemp$

' Get FIRST alias
' Aliases are stored as POINTER to POINTER(s) to name(s) - very annoying
aliastemp$ = ""
X% = 0
IF hAlias = 0 OR hAlias = &HFFFFFFFF THEN GOTO InvalidAliasPointer
DIM FirstAliasPointer32 AS LONG
CALL MoveIntoVariable(VARPTR(FirstAliasPointer32), VARSEG(FirstAliasPointer32), hAlias, 4)

IF FirstAliasPointer32 = 0 OR FirstAliasPointer32 = &HFFFFFFFF THEN GOTO InvalidAliasPointer
' ***Finally*** we have a FLAT pointer to the first alias
DO
  NextChar$ = CHR$(PEEK32%(FirstAliasPointer32 + X%))
  IF NextChar$ = CHR$(0) THEN EXIT DO
  aliastemp$ = aliastemp$ + NextChar$
  X% = X% + 1
LOOP
InvalidAliasPointer:
HostAlias = aliastemp$

AddrType = hAddrType
length = hLength

' IP addresses
' IP addresses field is similar to aliases
IPADDR = ""
IF hAddrList = 0 OR hAddrList = &HFFFFFFFF THEN GOTO InvalidAddrPointer
DIM AddrPointer32 AS LONG     ' Pointer to address list pointers

DO
  CALL MoveIntoVariable(VARPTR(AddrPointer32), VARSEG(AddrPointer32), hAddrList, 4)
  IF AddrPointer32 = 0 THEN EXIT DO
  IPAddressField$ = ""
  FOR X% = 0 TO 3
    NextChar$ = CHR$(PEEK32%(AddrPointer32 + X%))
    IPAddressField$ = IPAddressField$ + NextChar$
  NEXT X%
  hAddrList = hAddrList + 4
  IPADDR = IPADDR + IPAddressField$
  IF GetMultiple = 0 THEN GOTO SkipInvalidAddrPointer
LOOP

InvalidAddrPointer:
IPADDR = IPADDR + STRING$(4, 0)

SkipInvalidAddrPointer:

ErrorValue = 0

END SUB

