; Source code for WSLOADER.EXE

; This is simply Iczelion's win32 asm tutorial 3. It was supposed to show
; how to make a simple window appear, but I've just edited it a little by
; putting in afew "DeviceIOControl" calls.

; Compiled using MASM32. Requires WINDOWS.INC, USER32.INC, KERNEL32.INC,
; USER32.LIB and KERNEL32.LIB (included with MASM32).

; Thanks Iczelion for the great tutorials!

.386
.model flat,stdcall
option casemap:none
include windows.inc
include user32.inc
include kernel32.inc
include ws2_32.inc
includelib user32.lib
includelib kernel32.lib
includelib ws2_32.lib

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

.data
ClassName       db      "SimpleWinClass",0
AppName         db      "a",0
VxDName         db      "\\.\WSOCKXS.VXD",0
ObjName         db      "CowsGoMooLikeMe",0

.data?           

; Things
hInstance       HINSTANCE       ?
CommandLine     LPSTR           ?
hVxD            dd              ?
hFileMap        dd              ?
hFileView       dd              ?
ThreadParam     dd              ?
ThreadId        dd              ?

; Message data structure
hwnd            HWND            ?
message         UINT            ?
wparam          WPARAM          ?
lparam          LPARAM          ?

; Record data structure
LinearAddress   dd              ?
GlobalAlias     dd              ?
RecordType      dw              ?
RecordMessage   dw              ?
AsyncTaskHandle dd              ?

FunctionNumber  dd              ?
CallBufferPtr   dd              ?
FunctionReturn  dd              ?
WinsockError    dd              ?

IsWinNT         dd              ?

.code
start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  GetCommandLine
        mov     CommandLine,eax

        invoke  WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT

        ; On closure of the program, the program will either clear the
        ; shared memory or close the VxD

        push    eax
        .if IsWinNT==1
                invoke  UnmapViewOfFile,hFileView
                invoke  CloseHandle,hFileMap
        .else
                invoke  TerminateThread,ThreadId,0
                invoke  CloseHandle,ThreadId
                invoke  CloseHandle,hVxD
        .endif
        pop     eax
        invoke  ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

        LOCAL   wc:WNDCLASSEX
        LOCAL   msg:MSG
        LOCAL   getver:OSVERSIONINFO

        ; Find out whether we are in windows NT and create shared memory
        ; if we are, otherwise load VxD
        mov     IsWinNT,0
        mov     getver.dwOSVersionInfoSize,sizeof OSVERSIONINFO
        invoke  GetVersionEx,addr getver
        .if getver.dwPlatformId==VER_PLATFORM_WIN32_NT
                ; Create a memory mapped file object (for memory sharing)                
                mov     IsWinNT,1
                invoke  CreateFileMapping,INVALID_HANDLE_VALUE,NULL,\
                        PAGE_READWRITE,0,4112,addr ObjName
                mov     hFileMap,eax
                invoke  MapViewOfFile,eax,FILE_MAP_ALL_ACCESS,0,0,4112
                mov     hFileView,eax
                ; SNOZZBERRY there are two cases of checking for errors to
                ; be done here
        .else
                ; This will load the VxD. The handle for the VxD needs to be
                ; stored for DeviceIoControl calls.
                invoke  CreateFile,addr VxDName,0,0,0,0,\
                        FILE_FLAG_DELETE_ON_CLOSE,0
                mov     hVxD,eax
        .endif

        ; Register class and create a window
        mov     wc.cbSize,SIZEOF WNDCLASSEX
        mov     wc.style,CS_HREDRAW or CS_VREDRAW
        mov     wc.lpfnWndProc,OFFSET WndProc
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL
        push    hInstance
        pop     wc.hInstance
        mov     wc.hbrBackground,COLOR_WINDOW+1
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,OFFSET ClassName
        invoke  LoadIcon,NULL,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hIconSm,eax
        invoke  LoadCursor,NULL,IDC_ARROW
        mov     wc.hCursor,eax
        invoke  RegisterClassEx,addr wc
        INVOKE  CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
                WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
                CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
                hInst,NULL
        mov     hwnd,eax

        .if IsWinNT==1                     
                ; Place our window handle in the shared memory
                mov     eax,hFileView
                add     eax,1000h
                mov     ebx,hwnd
                mov     [eax],ebx
                xor     ecx,ecx
                mov     word ptr[eax+06h],cx
                mov     [eax+08h],ecx ; Reset message queue pointers 
                mov     [eax+0ch],ecx
                mov     word ptr[eax+04h],0ffh
        .else                
                mov     eax,offset MyThreadProc
                invoke  CreateThread,NULL,NULL,eax,addr ThreadParam,0,\
                        addr ThreadId
                ; SNOZZBERRY check for errors
                mov     ThreadId,eax
        .endif


        ; Because the window has to be invisible and non-accessible, we
        ; do not show it.
        ; invoke  ShowWindow,hwnd,SW_SHOWNORMAL
        ; invoke  UpdateWindow,hwnd

	.WHILE TRUE
                invoke  GetMessage,ADDR msg,NULL,0,0                
                .BREAK  .IF (!eax)
                invoke  TranslateMessage,ADDR msg
                invoke  DispatchMessage,ADDR msg
        .ENDW

        mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM        
        .if uMsg==WM_DESTROY
                invoke  PostQuitMessage,NULL

        .elseif uMsg > WM_USER
                
                ; This will copy all the details of the message sent into a
                ; buffer. 
                ; If we are in windows NT, it copies it into shared memory,
                ; otherwise signal the VxD

                mov     eax,hWnd
                mov     hwnd,eax
                mov     eax,uMsg
                mov     message,eax
                mov     eax,wParam
                mov     wparam,eax
                mov     eax,lParam                
                mov     lparam,eax

                .if IsWinNT==1                        
                        ; Copy the message into shared memory.                        
                        mov     eax,hFileView
                        add     eax,1000h
                        cmp     byte ptr[eax+06h],0ffh ; Is byte enabled?
                        jne     ByteNotEnabled
                        mov     esi,offset hwnd
                        mov     edi,hFileView
                        add     edi,[eax+0ch]
                        mov     ecx,4
                        rep     movsd
                        add     dword ptr[eax+0ch],16
                        and     dword ptr[eax+0ch],0fffh

                ByteNotEnabled:

                .else
                        ; Signal the VxD

                        invoke  DeviceIoControl,hVxD,2,ADDR hwnd,16,NULL,\
                                NULL,NULL,NULL

                        .if uMsg > 1000h
                                mov     ecx,3
                        ClearLoop1:
                                push    ecx
                                mov     eax,wParam
                                mov     AsyncTaskHandle,eax
                                invoke  DeviceIoControl,hVxD,9,\
                                        ADDR LinearAddress,16,NULL,NULL,\
                                        NULL,NULL
                                pop     ecx
                                loop    ClearLoop1
                        .endif
                .endif

        .else
                invoke DefWindowProc,hWnd,uMsg,wParam,lParam     
                ret
        .endif
        xor     eax,eax
        ret

WndProc endp

MyThreadProc proc Param1:DWORD

        ; Inform the VxD what the window's handle and thread's
        ; handle is. This is required for the VxD to send messages
        ; to, and to know what to pass in WSAAsyncSelect.        

        invoke  DeviceIoControl,hVxD,5,NULL,NULL,addr CallBufferPtr,\
                4,NULL,NULL
        invoke  DeviceIoControl,hVxD,1,addr hwnd,4,NULL,NULL,NULL,\
                NULL
        
        ; This loop will simply go round until the thread is terminated

LoopForever:
        invoke  SleepEx,INFINITE,TRUE
        call    ApcProc
        jmp     LoopForever

        ret

MyThreadProc endp

ApcProc proc
        
        invoke  DeviceIoControl,hVxD,8,NULL,NULL,addr FunctionNumber,4,NULL,\
                NULL

        mov     eax,FunctionNumber
        mov     ebx,CallBufferPtr
        .if eax==0
                ; "return byte" - rather misleading, since all the
                ; function does is call the VxD back. However, the
                ; current thread (and hence context) will be this
                ; one's, and we can globally map pages.
                invoke  DeviceIoControl,hVxD,6,NULL,NULL,NULL,NULL,NULL,NULL

        .elseif eax==1
                invoke  WSAStartup,[ebx+04h],[ebx+08h]
                mov     FunctionReturn,eax
                mov     ecx,[ebx+08h]
                mov     GlobalAlias,ecx
                invoke  DeviceIoControl,hVxD,4,addr LinearAddress,8,NULL,\
                        NULL,NULL,NULL

        .elseif eax==2
                invoke  WSACleanup
                mov     FunctionReturn,eax
                .if eax==-1
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                .else
                        mov     WinsockError,0
                .endif

        .elseif eax==3  
                ; We cannot simply call WSAGetLastError here since
                ; that sometimes relies on kernel32's SetLastError
                ; function, and in the process of calling
                ; DeviceIoControl things get stuffed up... so we
                ; have to detect it immediately and store it for
                ; later.
                mov     eax,WinsockError
                mov     FunctionReturn,eax

        .elseif eax==4
                invoke  gethostbyaddr,[ebx+04h],[ebx+08h],[ebx+0ch]
                mov     FunctionReturn,eax
                .if eax==0
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                .else
                        mov     WinsockError,0
                .endif
                mov     ecx,[ebx+04h]
                mov     GlobalAlias,ecx
                invoke  DeviceIoControl,hVxD,4,addr LinearAddress,8,NULL,\
                        NULL,NULL,NULL

        .elseif eax==5
                invoke  gethostbyname,[ebx+04h]                
                mov     FunctionReturn,eax
                .if eax==0
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                .else
                        mov     WinsockError,0
                .endif
                mov     ecx,[ebx+04h]
                mov     GlobalAlias,ecx
                invoke  DeviceIoControl,hVxD,4,addr LinearAddress,8,NULL,\
                        NULL,NULL,NULL

        .elseif eax==6
                invoke  getprotobyname,[ebx+04h]
                mov     FunctionReturn,eax
                .if eax==0
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                .else
                        mov     WinsockError,0
                .endif
                mov     ecx,[ebx+04h]
                mov     GlobalAlias,ecx
                invoke  DeviceIoControl,hVxD,4,addr LinearAddress,8,NULL,\
                        NULL,NULL,NULL

        .elseif eax==7
                invoke  getprotobynumber,[ebx+04h]
                mov     FunctionReturn,eax
                .if eax==0
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                .else
                        mov     WinsockError,0
                .endif
                
        .elseif eax==8
                invoke  getservbyname,[ebx+04h],[ebx+08h]
                mov     FunctionReturn,eax
                .if eax==0
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                .else
                        mov     WinsockError,0
                .endif
                mov     ecx,[ebx+04h]
                mov     GlobalAlias,ecx
                invoke  DeviceIoControl,hVxD,4,addr LinearAddress,8,\
                        NULL,NULL,NULL,NULL
                mov     ecx,[ebx+08h]
                mov     GlobalAlias,ecx
                invoke  DeviceIoControl,hVxD,4,addr LinearAddress,8,NULL,\
                        NULL,NULL,NULL

        .elseif eax==9
                invoke  getservbyport,[ebx+04h],[ebx+08h]
                mov     FunctionReturn,eax
                .if eax==0
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                .else
                        mov     WinsockError,0
                .endif
                mov     ecx,[ebx+08h]
                mov     GlobalAlias,ecx
                invoke  DeviceIoControl,hVxD,4,addr LinearAddress,8,NULL,\
                        NULL,NULL,NULL

        .elseif eax==10
                invoke  gethostname,[ebx+04h],[ebx+08h]
                mov     FunctionReturn,eax
                .if eax==-1
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                .else
                        mov     WinsockError,0
                .endif
                mov     ecx,[ebx+04h]
                mov     GlobalAlias,ecx
                invoke  DeviceIoControl,hVxD,4,addr LinearAddress,8,NULL,\
                        NULL,NULL,NULL

        .elseif eax==11
                invoke  WSAAsyncGetHostByAddr,[ebx+04h],[ebx+08h],[ebx+0ch],\
                        [ebx+10h],[ebx+14h],[ebx+18h],[ebx+1ch]
                mov     FunctionReturn,eax
                .if eax==0
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                        mov     ecx,[ebx+0ch]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,10,addr LinearAddress,\
                                8,NULL,NULL,NULL,NULL
                        mov     ecx,[ebx+18h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,10,addr LinearAddress,\
                                8,NULL,NULL,NULL,NULL
                .else
                        mov     WinsockError,0
                        mov     AsyncTaskHandle,eax
                        mov     ecx,[ebx+0ch]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,3,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                        mov     ecx,[ebx+18h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,3,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                .endif

        .elseif eax==12
                invoke  WSAAsyncGetHostByName,[ebx+04h],[ebx+08h],[ebx+0ch],\
                        [ebx+10h],[ebx+14h]
                mov     FunctionReturn,eax
                .if eax==0
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                        mov     ecx,[ebx+0ch]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,10,addr LinearAddress,\
                                8,NULL,NULL,NULL,NULL
                        mov     ecx,[ebx+10h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,10,addr LinearAddress,\
                                8,NULL,NULL,NULL,NULL
                .else
                        mov     WinsockError,0
                        mov     AsyncTaskHandle,eax
                        mov     ecx,[ebx+0ch]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,3,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                        mov     ecx,[ebx+10h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,3,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                .endif

        .elseif eax==13
                invoke  WSAAsyncGetProtoByNumber,[ebx+04h],[ebx+08h],\
                        [ebx+0ch],[ebx+10h],[ebx+14h]
                mov     FunctionReturn,eax
                .if eax==0
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                        mov     ecx,[ebx+10h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,10,addr LinearAddress,\
                                8,NULL,NULL,NULL,NULL
                .else
                        mov     WinsockError,0
                        mov     AsyncTaskHandle,eax
                        mov     ecx,[ebx+10h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,3,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                .endif

        .elseif eax==14
                invoke  WSAAsyncGetProtoByName,[ebx+04h],[ebx+08h],\
                        [ebx+0ch],[ebx+10h],[ebx+14h]
                mov     FunctionReturn,eax
                .if eax==0
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                        mov     ecx,[ebx+0ch]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,10,addr LinearAddress,\
                                8,NULL,NULL,NULL,NULL
                        mov     ecx,[ebx+10h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,10,addr LinearAddress,\
                                8,NULL,NULL,NULL,NULL
                .else
                        mov     WinsockError,0
                        mov     AsyncTaskHandle,eax
                        mov     ecx,[ebx+0ch]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,3,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                        mov     ecx,[ebx+10h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,3,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                .endif

        .elseif eax==15
                invoke  WSAAsyncGetServByPort,[ebx+04h],[ebx+08h],[ebx+0ch],\
                        [ebx+10h],[ebx+14h],[ebx+18h]
                mov     FunctionReturn,eax
                .if eax==0
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                        mov     ecx,[ebx+10h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,10,addr LinearAddress,\
                                8,NULL,NULL,NULL,NULL
                        mov     ecx,[ebx+14h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,10,addr LinearAddress,\
                                8,NULL,NULL,NULL,NULL
                .else
                        mov     WinsockError,0
                        mov     AsyncTaskHandle,eax
                        mov     ecx,[ebx+10h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,3,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                        mov     ecx,[ebx+14h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,3,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                .endif

        .elseif eax==16
                invoke  WSAAsyncGetServByName,[ebx+04h],[ebx+08h],[ebx+0ch],\
                        [ebx+10h],[ebx+14h],[ebx+18h]
                mov     FunctionReturn,eax
                .if eax==0
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                        mov     ecx,[ebx+0ch]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,10,addr LinearAddress,\
                                8,NULL,NULL,NULL,NULL
                        mov     ecx,[ebx+10h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,10,addr LinearAddress,\
                                8,NULL,NULL,NULL,NULL
                        mov     ecx,[ebx+14h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,10,addr LinearAddress,\
                                8,NULL,NULL,NULL,NULL
                .else
                        mov     WinsockError,0
                        mov     AsyncTaskHandle,eax
                        mov     ecx,[ebx+0ch]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,3,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                        mov     ecx,[ebx+10h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,3,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                        mov     ecx,[ebx+14h]
                        mov     GlobalAlias,ecx
                        invoke  DeviceIoControl,hVxD,3,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                .endif

        .elseif eax==17
                invoke  WSACancelAsyncRequest,[ebx+04h]
                mov     FunctionReturn,eax
                .if eax==-1
                        invoke  WSAGetLastError
                        mov     WinsockError,eax
                .else
                        mov     WinsockError,0
                        mov     ecx,3
                ClearLoop2:
                        mov     eax,[ebx+04h]
                        mov     AsyncTaskHandle,eax
                        push    ecx
                        push    ebx
                        invoke  DeviceIoControl,hVxD,9,addr LinearAddress,\
                                16,NULL,NULL,NULL,NULL
                        pop     ebx
                        pop     ecx
                        loop    ClearLoop2
                .endif

        .endif

        .if FunctionNumber!=0ffffh
                invoke  DeviceIoControl,hVxD,7,addr FunctionReturn,4,NULL,\
                        NULL,NULL,NULL
        .endif

        ret

ApcProc endp


end start
