; Source code for WSOCKQB.OBJ (and consequently WSOCKQB.LIB and WSOCKQB.QLB).
; As far as I've looked no external include files or libraries are needed
; (with the exception of BQLB45.LIB needed to produce a .QLB)

; Compiled using MASM 6.14

.MODEL large,basic
.386
.STACK 100h



DSEG    SEGMENT PARA PUBLIC USE16 'DATA'

FARPTR                  TYPEDEF FAR PTR DWORD

WSOCK2CallBuffer        dd      16 DUP (0)
WSOCK2Entry             FARPTR  ?
VXDLDREntry             FARPTR  ?
WSOCKXSEntry            FARPTR  ?
WSOCK2Name              db      "WSOCK2.VXD",0
WSOCKXSName             db      "WSOCKXS ",0

; IOStatus block
IOReturnValue           dd      0
IOSignal                dd      0
IOUnknown1              dd      0
IOUnknown2              dd      0

; Some things
RecieveArrayBuffer      dd      2 DUP (0)
SendArrayBuffer         dd      2 DUP (0)
SelectBuffer            dd      3 DUP (0)
LastSocketHandle        dd      0
AsyncOverride           db      0 ; If this is set, do not translate
                                  ; address for asynchronous database calls
Padding1                db      0

; Things for VDD
VddHandle               dw      0
DLLName                 db      "ntwsock.dll",0
EntryName               db      "InitRoutine",0
DispatchName            db      "HelloWorld",0
DllLoaded               db      0
UseVdd                  db      0
InitSuccess             db      0

; Error variables
LastError               dw      0
RealErrorResponse       db      0

; Timer variables
TimerOffset             dd      0
TimerValue              dd      0
TimerRunning            db      0 
Padding3                db      3 DUP (0)

DSEG            ENDS





CSEG            SEGMENT PARA PUBLIC USE16 'CODE'
ASSUME          CS:CSEG,DS:DSEG,ES:NOTHING


COPY            MACRO source,dest
mov     eax,source
mov     dest,eax
                ENDM


ENTERSTACK      MACRO
push    bp
mov     bp,sp
push    ds
mov     ax,DSEG
mov     ds,ax
push    es
push    bx
                ENDM


LEAVESTACK      MACRO bytesleft
pop     bx
pop     es
pop     ds
pop     bp
retf    bytesleft
                ENDM


PUBLIC          WSInit
WSInit          PROC FAR

push    ds
mov     ax,DSEG
mov     ds,ax
push    dx
push    cx
push    bx
push    es
push    di
push    si
; Find VXDLDR entry point - if it is NULL report error
xor     ax,ax
mov     es,ax
xor     di,di
mov     ax,1684h
mov     bx,27h    ; 27h = Device ID for VXDLDR
int     2fh       ; INT 2F function 1684h - Get VxD entry point
                  ; On entry: AX = 1684h
                  ;           BX = Device ID
                  ; Returns: ES:DI entry point (NULL if not available)
mov     ax,es
mov     word ptr[VXDLDREntry+00h],di
mov     word ptr[VXDLDREntry+02h],ax
or      ax,ax
jnz     VXDLDREntryPointValid

; VXDLDR had invalid entry point (windows probably not loaded)

; Now we test whether we are in a windows NT box
; This method is what Berczi Gabor used in wsockvdd.asm. If you know another
; way to detect a windows NT box please tell me.
mov     ax,3306h
xor     bx,bx
int     21h
cmp     al,0ffh
je      NoWinNT
cmp     bx,3205h
jne     NoWinNT

; Test to see if it's already loaded
mov     UseVdd,1
cmp     DllLoaded,0ffh
jne     DllNotLoaded
jmp     DllIsLoaded

DllNotLoaded:
; Try to load the DLL
push    ds
pop     es
mov     si,offset DllName
mov     di,offset EntryName
mov     bx,offset DispatchName
db      0c4h,0c4h,58h,0 ; Register module
jc      VddLoadError

DllIsLoaded:
; OK, it was loaded and the init routine called (and was successful)
mov     VddHandle,ax
mov     DllLoaded,0ffh
cmp     InitSuccess,0
je      InitialiseTheDll
cmp     InitSuccess,1
je      WaitForHWnd

; It's already loaded
xor     ax,ax
jmp     WSInitEND

InitialiseTheDll:
mov     ax,VddHandle
mov     dx,46
db      0c4h,0c4h,58h,2
or      ax,ax
jz      WaitForHWnd
jmp     WSInitEND

WaitForHWnd:
; Wait for WSLOADER.EXE to execute and for hWnd to become valid
mov     InitSuccess,1
mov     ax,VddHandle
mov     dx,42
db      0c4h,0c4h,58h,2
or      ax,ax
jz      WSInitSuccess2
cmp     ax,-1
je      WaitForHWnd
jmp     WSInitEND

WSInitSuccess2:
call    StopTimer ; Stop and reset timer
call    ResetTimer
mov     InitSuccess,0ffh
xor     ax,ax
jmp     WSInitEND

NoWinNT:
mov     ax,0ffffh
jmp     WSInitEND

VddLoadError:
; AX will be the error. Since we are expecting negative values, negate AX.
; Note that 1 maps onto -10, 2 maps to -11, 3 maps to -12 and 4 maps to -13
add     eax,9
neg     eax
jmp     WSInitEND

VXDLDREntryPointValid:
; Find WSOCK2.VXD entry point - is it already loaded?
xor     ax,ax
mov     es,ax
xor     di,di
mov     ax,1684h
mov     bx,3b0ah ; 3B0Ah = Device ID for WSOCK2
int     2fh
mov     ax,es
mov     word ptr[WSOCK2Entry+00h],di
mov     word ptr[WSOCK2Entry+02h],ax
or      ax,ax
jnz     WSOCK2LoadSuccess ; If already loaded then skip ahead

LoadWSOCK2:
; Otherwise load WSOCK2.VXD using VXDLDR
mov     ax,1
; DS already points at DSEG
mov     dx,offset WSOCK2Name
call    VXDLDREntry
jnc     TestWSOCK2Entry ; Carry flag clear on success

; WSOCK2.VXD could not be loaded
mov     ax,0fffeh ; Error -2
jmp     WSInitEND

TestWSOCK2Entry:
; Test to see if WSOCK2.VXD entry point is valid (after loading)
xor     ax,ax
mov     es,ax
xor     di,di
mov     ax,1684h
mov     bx,3b0ah
int     2fh
mov     ax,es
mov     word ptr[WSOCK2Entry+00h],di
mov     word ptr[WSOCK2Entry+02h],ax
or      ax,ax
jnz     WSOCK2LoadSuccess

; WSOCK2.VXD did not have a valid entry point, even after loading
mov     ax,0fffdh ; Error -3
jmp     WSInitEND

WSOCK2LoadSuccess:
; Test WSOCKXS entry point (WSLOADER is supposed to load it)
push    ds
pop     es
mov     di,offset WSOCKXSName
mov     ax,1684h
xor     bx,bx
int     2fh
mov     ax,es
mov     word ptr[WSOCKXSEntry+00h],di
mov     word ptr[WSOCKXSEntry+02h],ax

; Is entry point NULL?
or      ax,ax
jnz     HasESDIChanged

; Yes it is NULL
mov     ax,0fffch ; Error -4
jmp     WSInitEND

HasESDIChanged:
; Has ES:DI remained unchanged?
push    ds
pop     bx
cmp     ax,bx
jne     CheckAppyTime ; If segment has changed skip ahead

; Has DI remained unchanged?
cmp     di,offset WSOCKXSName
jne     CheckAppyTime ; If offset has changed skip ahead

; Offset hasn't changed --> ES:DI unchanged
mov     ax,0fffch ; Error -4
jmp     WSInitEND

CheckAppyTime:
; Queries if application time is available
; This is now obsolete since appy time is no longer used, but things above
; reference to this label so I'm not going to remove it.

AppyTimeAvailable:
mov     AsyncOverride,0
call    StopTimer ; Stop and reset timer
call    ResetTimer    

; Loop until window handle is valid. Note that if it never becomes valid,
; this loop could loop forever...
; If AX is non-zero handle is valid
HWndInvalid:
mov     ax,24h
call    WSOCKXSEntry
or      ax,ax
jz      HWndInvalid

; WSInit returns 0 = success (finally!)
xor     ax,ax

WSInitEND:
pop     si
pop     di
pop     es
pop     bx
pop     cx
pop     dx
pop     ds
retf

WSInit          ENDP


; All the standard functions usually take on the following form:
; 1. Setup stack frame
; 2. Transfer bytes from stack frame (ie. call parameters) to a buffer
;    that will be passed to WSOCK2.VXD. This buffer is different for every
;    function. See WS2FUNCT.TXT for details on these buffers.
; 3. Call WSOCK2.VXD
; 4. If -1 was returned, do some sort of blocking.
; 5. Place a return value in DX:AX. Usually -1 indicates an error and 0
;    indicates success. Some functions, such as send, may return something
;    else (in this case the number of bytes actually sent).
; 6. Place an extended error value in "LastError".
; 7. Return from procedure.

; Notes:
; recv and send simply call recvfrom and sendto with NULL values for
; the address and address length.
; recvfrom and sento block using selectsocket.
; socket and accept use the current time as a socket handle.


PUBLIC          accept
accept          PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,1
        db      0c4h,0c4h,58h,2
        mov     word ptr[LastSocketHandle],ax
        mov     word ptr[LastSocketHandle+02h],dx
.else        
        call    ZeroBuffer
        mov     eax,LastSocketHandle
        inc     eax
        mov     dword ptr[WSOCK2CallBuffer+10h],eax
        mov     LastSocketHandle,eax
        xor     eax,eax

        COPY    dword ptr[bp+0eh],dword ptr[WSOCK2CallBuffer+04h]
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+00h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+0Ch]

        mov     dword ptr[WSOCK2CallBuffer+14h],0ffffffffh

        mov     ax,offset IOReturnValue
        mov     word ptr[WSOCK2CallBuffer+18h],ax
        mov     ax,ds
        mov     word ptr[WSOCK2CallBuffer+1Ah],ax

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,100h
        call    WSOCK2Entry
        cmp     ax,0ffffh
        jne     acceptNoBlock
        call    DoBlock

acceptNoBlock:
        or      ax,ax
        jnz     acceptError
        mov     ax,word ptr[WSOCK2CallBuffer+08h]
        mov     dx,word ptr[WSOCK2CallBuffer+0Ah]
        jmp     acceptEND

acceptError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

acceptEND:
.endif

LEAVESTACK 0ch

accept          ENDP


PUBLIC          bind
bind            PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,2
        db      0c4h,0c4h,58h,2
.else        
        call    ZeroBuffer
        COPY    dword ptr[bp+0eh],dword ptr[WSOCK2CallBuffer+04h]
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+00h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+08h]

        mov     dword ptr[WSOCK2CallBuffer+0Ch],0ffffffffh

        mov     ax,offset IOReturnValue
        mov     word ptr[WSOCK2CallBuffer+10h],ax
        mov     ax,ds
        mov     word ptr[WSOCK2CallBuffer+12h],ax

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,101h
        call    WSOCK2Entry
        cmp     ax,0ffffh
        jne     bindNoBlock
        call    DoBlock

bindNoBlock:
        or      ax,ax
        jnz     bindError
        xor     ax,ax
        mov     dx,ax
        jmp     bindEND

bindError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

bindEND:
.endif

LEAVESTACK 0ch

bind            ENDP


PUBLIC          closesocket
closesocket     PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,3
        db      0c4h,0c4h,58h,2
.else
        call    ZeroBuffer
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+00h]

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,102h
        call    WSOCK2Entry
        or      ax,ax
        jnz     closesocketError
        xor     ax,ax
        mov     dx,ax
        jmp     closesocketEND

closesocketError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

closesocketEND:
.endif

LEAVESTACK 04h

closesocket     ENDP


PUBLIC          connect
connect         PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,4
        db      0c4h,0c4h,58h,2
.else
        call    ZeroBuffer
        COPY    dword ptr[bp+0eh],dword ptr[WSOCK2CallBuffer+04h]
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+00h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+08h]

        mov     dword ptr[WSOCK2CallBuffer+0Ch],0ffffffffh

        mov     ax,offset IOReturnValue
        mov     word ptr[WSOCK2CallBuffer+10h],ax
        mov     ax,ds
        mov     word ptr[WSOCK2CallBuffer+12h],ax

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,103h
        call    WSOCK2Entry
        cmp     ax,0ffffh
        jne     connectNoBlock
        call    DoBlock

connectNoBlock:
        or      ax,ax
        jnz     connectError
        xor     ax,ax
        mov     dx,ax
        jmp     connectEND

connectError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

connectEND:
.endif

LEAVESTACK 0ch

connect         ENDP


PUBLIC          getpeername
getpeername     PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,5
        db      0c4h,0c4h,58h,2
.else
        call    ZeroBuffer
        COPY    dword ptr[bp+0eh],dword ptr[WSOCK2CallBuffer+04h]
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+00h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+08h]

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,104h
        call    WSOCK2Entry
        or      ax,ax
        jnz     getpeernameError
        xor     ax,ax
        mov     dx,ax
        jmp     getpeernameEND

getpeernameError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

getpeernameEND:
.endif

LEAVESTACK 0ch

getpeername     ENDP


PUBLIC          getsockname
getsockname     PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,6
        db      0c4h,0c4h,58h,2
.else
        call    ZeroBuffer
        COPY    dword ptr[bp+0eh],dword ptr[WSOCK2CallBuffer+04h]
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+00h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+08h]
        
        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,105h
        call    WSOCK2Entry
        or      ax,ax
        jnz     getsocknameError
        xor     ax,ax
        mov     dx,ax
        jmp     getsocknameEND

getsocknameError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

getsocknameEND:
.endif

LEAVESTACK 0ch

getsockname     ENDP


PUBLIC          getsockopt
getsockopt      PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,7
        db      0c4h,0c4h,58h,2
.else
        call ZeroBuffer
        COPY    dword ptr[bp+16h],dword ptr[WSOCK2CallBuffer+04h]
        COPY    dword ptr[bp+12h],dword ptr[WSOCK2CallBuffer+08h]
        COPY    dword ptr[bp+0eh],dword ptr[WSOCK2CallBuffer+0ch]
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+00h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+10h]

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,106h
        call    WSOCK2Entry
        or      ax,ax
        jnz     getsockoptError

        xor     ax,ax
        mov     dx,ax
        jmp     getsockoptEND

getsockoptError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

getsockoptEND:
.endif

LEAVESTACK 14h

getsockopt      ENDP


PUBLIC          htonl
htonl           PROC FAR

; No data segment is needed since this is just a simple operation
push    bp
mov     bp,sp
mov     ax,[bp+08h]
mov     dx,[bp+06h]
xchg    al,ah
xchg    dl,dh
pop     bp
retf    04h

htonl           ENDP


PUBLIC          htons
htons           PROC FAR

; No data segment needed for this simple function
push    bp
mov     bp,sp
mov     ax,[bp+06h]
xchg    al,ah
pop     bp
retf    02h

htons           ENDP


PUBLIC          ioctlsocket
ioctlsocket     PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,8
        db      0c4h,0c4h,58h,2
.else
        call    ZeroBuffer
        COPY    dword ptr[bp+0eh],dword ptr[WSOCK2CallBuffer+00h]
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+04h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+08h]

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,107h
        call    WSOCK2Entry
        or      ax,ax
        jnz     ioctlsocketError
        xor     ax,ax
        mov     dx,ax
        jmp     ioctlsocketEND

ioctlsocketError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

ioctlsocketEND:
.endif

LEAVESTACK 0ch

ioctlsocket     ENDP


PUBLIC          listen
listen          PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,9
        db      0c4h,0c4h,58h,2
.else
        call ZeroBuffer
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+00h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+04h]

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,108h
        call    WSOCK2Entry
        or      ax,ax
        jnz     listenError
        xor     ax,ax
        mov     dx,ax
        jmp     listenEND

listenError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax
        
listenEND:
.endif

LEAVESTACK 08h

listen          ENDP


PUBLIC          ntohl
ntohl           PROC FAR

; No data segment needed for this simple function
push    bp
mov     bp,sp
mov     ax,[bp+08h]
mov     dx,[bp+06h]
xchg    al,ah
xchg    dl,dh
pop     bp
retf    04h
ntohl           ENDP


PUBLIC          ntohs
ntohs           PROC FAR

; No data segment for this even simpler function
push    bp
mov     bp,sp
mov     ax,[bp+06h]
xchg    al,ah
pop     bp
retf    02h

ntohs           ENDP

        
PUBLIC          recv
recv            PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,10
        db      0c4h,0c4h,58h,2
.else
        push    dword ptr[bp+12h]
        push    dword ptr[bp+0eh]
        push    dword ptr[bp+0ah]
        push    dword ptr[bp+06h]
        xor     eax,eax
        push    eax
        push    eax
        call    recvfrom
.endif

LEAVESTACK 10h

recv            ENDP


PUBLIC          recvfrom
recvfrom        PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,11
        db      0c4h,0c4h,58h,2
.else
DoRecv:
        call    ZeroBuffer
        COPY    dword ptr[bp+1ah],dword ptr[WSOCK2CallBuffer+0ch]

        ; Qbasic actually returns pointer to string descriptor
        ; Qbasic also has the offset and segement round the opposite way
        ; STRING DESCRIPTOR:
        ;   2 bytes - Length
        ;   2 bytes - Pointer to string data
        mov     dx,[bp+18h]
        mov     es,dx
        mov     bx,word ptr[bp+16h]
        mov     ax,word ptr es:[bx+02h]
        mov     word ptr[RecieveArrayBuffer+04h],ax
        mov     word ptr[RecieveArrayBuffer+06h],dx

        COPY    dword ptr[bp+12h],dword ptr[RecieveArrayBuffer+00h]

        mov     ax,offset RecieveArrayBuffer
        mov     word ptr[WSOCK2CallBuffer+00h],ax
        mov     ax,ds
        mov     word ptr[WSOCK2CallBuffer+02h],ax
        
        mov     word ptr[WSOCK2CallBuffer+10h],1

        COPY    dword ptr[bp+0eh],dword ptr[WSOCK2CallBuffer+18h]
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+04h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+14h]

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,109h
        call    WSOCKXSEntry
        cmp     ax,0ffffh
        jne     recvNoBlock

recvLoop1:
        push    dword ptr[bp+1ah]
        push    dword ptr 1 ; FD_READ
        call    selectsocket
        or      ax,ax
        jz      recvLoop1
        jmp     DoRecv

recvNoBlock:
        or      ax,ax
        jnz     recvError
        mov     ax,word ptr[WSOCK2CallBuffer+1Ch]
        mov     dx,word ptr[WSOCK2CallBuffer+1Eh]
        jmp     recvEND

recvError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

recvEND:
.endif

LEAVESTACK 18h

recvfrom        ENDP


PUBLIC          selectsocket
selectsocket    PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,12
        db      0c4h,0c4h,58h,2
.else
        push    si
        push    di
        push    ecx
        call    ZeroBuffer

        xor     eax,eax
        push    ds
        pop     es
        mov     di,offset SelectBuffer
        mov     ecx,6
        rep     stosd

        mov     dx,[bp+06h]
        .if dx==1 || dx==8 || dx==20h   ; FDREAD, FDACCEPT or FDCLOSE
                xor     bx,bx
                COPY    dword ptr[bp+0ah],dword ptr[SelectBuffer+00h]
                COPY    dword ptr[bp+06h],dword ptr[SelectBuffer+04h]
        .elseif dx==2 || dx==10h        ; FDWRITE or FDCONNECT
                mov     bx,08h
                COPY    dword ptr[bp+0ah],dword ptr[SelectBuffer+08h]
                COPY    dword ptr[bp+06h],dword ptr[SelectBuffer+0ch]
        .else                           ; Anything else
                mov     bx,10h
                COPY    dword ptr[bp+0ah],dword ptr[SelectBuffer+10h]
                COPY    dword ptr[bp+06h],dword ptr[SelectBuffer+14h]
        .endif
        push    bx ; Save for later
        mov     ax,offset SelectBuffer
        mov     word ptr[WSOCK2CallBuffer+00h],ax
        mov     ax,ds
        mov     word ptr[WSOCK2CallBuffer+02h],ax
        mov     word ptr[WSOCK2CallBuffer+0Ch],1

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,10bh
        call    WSOCK2Entry
        pop     si ; Restore from before
        or      ax,ax
        jnz     selectError

        xor     dx,dx
        mov     eax,[bp+0Ah]
        mov     bx,offset SelectBuffer
        cmp     dword ptr[bx+si],eax
        jne     selectNotComplete
        mov     ax,1
        jmp     selectEND

selectNotComplete:
        xor     ax,ax
        jmp     selectEND

selectError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

selectEND:
        pop     ecx
        pop     di
        pop     si
.endif

LEAVESTACK 08h

selectsocket    ENDP


PUBLIC          send
send            PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,13
        db      0c4h,0c4h,58h,2
.else
        push    dword ptr[bp+12h]
        push    dword ptr[bp+0eh]
        push    dword ptr[bp+0ah]
        push    dword ptr[bp+06h]
        xor     eax,eax
        push    eax
        push    eax
        call    sendto
.endif

LEAVESTACK 10h

send            ENDP


PUBLIC          sendto
sendto          PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,14
        db      0c4h,0c4h,58h,2
.else
        call    ZeroBuffer
        COPY    dword ptr[bp+1ah],dword ptr[WSOCK2CallBuffer+08h]

        ; Qbasic actually returns pointer to string descriptor
        ; Qbasic also has the offset and segement round the opposite way
        ; STRING DESCRIPTOR:
        ;   2 bytes - Length
        ;   2 bytes - Pointer to string data
        mov     dx,[bp+18h]
        mov     es,dx
        mov     bx,word ptr[bp+16h]
        mov     ax,word ptr es:[bx+02]
        mov     word ptr[SendArrayBuffer+04h],ax
        mov     word ptr[SendArrayBuffer+06h],dx

        COPY    dword ptr[bp+12h],dword ptr[SendArrayBuffer+00h]

        mov     ax,offset SendArrayBuffer
        mov     word ptr[WSOCK2CallBuffer+00h],ax
        mov     ax,ds
        mov     word ptr[WSOCK2CallBuffer+02h],ax

        mov     word ptr[WSOCK2CallBuffer+0Ch],1

        COPY    dword ptr[bp+0eh],dword ptr[WSOCK2CallBuffer+14h]
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+04h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+18h]

        mov     dword ptr[WSOCK2CallBuffer+20h],0ffffffffh

        mov     ax,offset IOReturnValue
        mov     word ptr[WSOCK2CallBuffer+24h],ax
        mov     ax,ds
        mov     word ptr[WSOCK2CallBuffer+26h],ax

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,10Dh
        call    WSOCKXSEntry
        cmp     ax,0ffffh
        jne     sendNoBlock
        call    DoBlock

sendNoBlock:
        or      ax,ax
        jnz     sendError
        mov     ax,word ptr[WSOCK2CallBuffer+1Ch] ; Bytes recieved
        mov     dx,word ptr[WSOCK2CallBuffer+1Eh]
        jmp     sendEND

sendError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

sendEND:
.endif

LEAVESTACK 18h

sendto          ENDP


PUBLIC          setsockopt
setsockopt      PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,15
        db      0c4h,0c4h,58h,2
.else
        call    ZeroBuffer
        COPY    dword ptr[bp+16h],dword ptr[WSOCK2CallBuffer+04h]
        COPY    dword ptr[bp+12h],dword ptr[WSOCK2CallBuffer+08h]
        COPY    dword ptr[bp+0eh],dword ptr[WSOCK2CallBuffer+0ch]
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+00h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+10h]

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,10Eh
        call    WSOCK2Entry
        or      ax,ax
        jnz     setsockoptError
        xor     ax,ax
        mov     dx,ax
        jmp     setsockoptEND

setsockoptError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

setsockoptEND:
.endif

LEAVESTACK 14h

setsockopt      ENDP


PUBLIC          shutdown
shutdown        PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,16
        db      0c4h,0c4h,58h,2
.else
        call    ZeroBuffer
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+00h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+04h]

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,10Fh
        call    WSOCK2Entry
        or      ax,ax
        jnz     shutdownError
        xor     ax,ax
        mov     dx,ax
        jmp     shutdownEND

shutdownError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

shutdownEND:
.endif

LEAVESTACK 08h

shutdown        ENDP


PUBLIC          socket
socket          PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,17
        db      0c4h,0c4h,58h,2
        mov     word ptr[LastSocketHandle],ax
        mov     word ptr[LastSocketHandle+02h],dx
.else
        call    ZeroBuffer
        mov     eax,LastSocketHandle
        inc     eax
        mov     dword ptr[WSOCK2CallBuffer+10h],eax
        mov     LastSocketHandle,eax
        xor     eax,eax

        COPY    dword ptr[bp+0eh],dword ptr[WSOCK2CallBuffer+00h]
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+04h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+08h]

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,110h
        call    WSOCK2Entry
        or      ax,ax
        jnz     socketError
        mov     ax,word ptr[WSOCK2CallBuffer+0Ch] ; Socket number
        mov     dx,word ptr[WSOCK2CallBuffer+0Eh]
        jmp     socketEND

socketError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

socketEND:
.endif

LEAVESTACK 0ch

socket          ENDP


; Database functions (and WSAStartup/WSACleanup) usually take the following
; form:
; 1. Make stack frame.
; 2. Enable DLL function completion byte
; 3. Allocate a selector, if a pointer is being passed
; 4. Transfer data from stack frame into DLL call buffer (also transferring
;    allocated selectors instead of pointers)
; 5. Set DLL function ordinal number, and number of bytes to pass
; 6. Call the function
; 7. Poll DLL function completion byte
; 8. Get a result using function AX = 10h
; 9. Free any allocated selectors
; 10. Disable DLL function completion byte


PUBLIC          WSAStartup
WSAStartup      PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,18
        db      0c4h,0c4h,58h,2
.else
        push    cx
        xor     dx,dx
        mov     cx,[bp+0ch]
        mov     bx,[bp+0ah]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,2
        mov     cx,[bp+08h]
        mov     bx,[bp+06h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,1
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif
LEAVESTACK 08h

WSAStartup      ENDP


PUBLIC          WSACleanup
WSACleanup      PROC FAR

push    ds
mov     ax,DSEG
mov     ds,ax

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,19
        db      0c4h,0c4h,58h,2
.else
        mov     dx,2
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
.endif
pop     ds
retf

WSACleanup      ENDP


PUBLIC          gethostbyaddr
gethostbyaddr   PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,20
        db      0c4h,0c4h,58h,2
.else
        push    cx
        mov     dx,2
        mov     cx,[bp+10h]
        mov     es,cx
        mov     bx,word ptr[bp+0eh]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+0ch]
        mov     bx,[bp+0ah]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+08h]
        mov     bx,[bp+06h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,4
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif

LEAVESTACK 0ch

gethostbyaddr   ENDP


PUBLIC          gethostbyname
gethostbyname   PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,21
        db      0c4h,0c4h,58h,2
.else
        push    cx
        mov     dx,2
        mov     cx,[bp+08h]
        mov     es,cx
        mov     bx,word ptr[bp+06h]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,5
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif

LEAVESTACK 04h

gethostbyname   ENDP


PUBLIC          getprotobyname
getprotobyname  PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,22
        db      0c4h,0c4h,58h,2
.else
        push    cx
        mov     dx,2
        mov     cx,[bp+08h]
        mov     es,cx
        mov     bx,word ptr[bp+06h]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,6
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif

LEAVESTACK 04h

getprotobyname  ENDP


PUBLIC          getprotobynumber
getprotobynumber        PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,23
        db      0c4h,0c4h,58h,2
.else
        push    cx
        xor     dx,dx
        mov     cx,[bp+08h]
        mov     bx,[bp+06h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,7
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif

LEAVESTACK 04h
getprotobynumber        ENDP


PUBLIC          getservbyname
getservbyname   PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,24
        db      0c4h,0c4h,58h,2
.else
        push    cx
        mov     dx,2
        mov     cx,[bp+0ch]
        mov     es,cx
        mov     bx,word ptr[bp+0ah]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,2
        mov     cx,[bp+08h]
        mov     es,cx
        mov     bx,word ptr[bp+06h]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,8
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif

LEAVESTACK 08h

getservbyname   ENDP


PUBLIC          getservbyport
getservbyport   PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,25
        db      0c4h,0c4h,58h,2
.else
        push    cx
        xor     dx,dx
        mov     cx,[bp+0ch]
        mov     bx,[bp+0ah]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,2
        mov     cx,[bp+08h]
        mov     es,cx
        mov     bx,word ptr[bp+06h]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,9
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif

LEAVESTACK 08h

getservbyport   ENDP


PUBLIC          WSAAsyncGetHostByAddr
WSAAsyncGetHostByAddr   PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     bl,AsyncOverride
        mov     dx,27
        db      0c4h,0c4h,58h,2
.else
        push    cx
        xor     dx,dx
        mov     cx,[bp+20h]
        mov     bx,[bp+1eh]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+1ch]
        mov     bx,[bp+1ah]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,1
        mov     cx,[bp+18h]
        mov     es,cx
        mov     bx,word ptr[bp+16h]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+14h]
        mov     bx,[bp+12h]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+10h]
        mov     bx,[bp+0eh]
        mov     ax,30h
        call    WSOCKXSEntry

        .if AsyncOverride==0
                mov     dx,1
                mov     cx,[bp+0ch]
                mov     es,cx
                mov     bx,word ptr[bp+0ah]
                mov     bx,word ptr es:[bx+02h]
                mov     ax,30h
                call    WSOCKXSEntry
        .else        
                xor     dx,dx
                mov     cx,[bp+0ch]
                mov     bx,[bp+0ah]
                mov     ax,30h
                call    WSOCKXSEntry
        .endif

        xor     dx,dx
        mov     cx,[bp+08h]
        mov     bx,[bp+06h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,11
        mov     ax,31h
        call    WSOCKXSEntry        
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif
mov     AsyncOverride,0

LEAVESTACK 1Ch

WSAAsyncGetHostByAddr   ENDP


PUBLIC          WSAAsyncGetHostByName
WSAAsyncGetHostByName   PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     bl,AsyncOverride
        mov     dx,28
        db      0c4h,0c4h,58h,2
.else
        push    cx
        xor     dx,dx
        mov     cx,[bp+18h]
        mov     bx,[bp+16h]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+14h]
        mov     bx,[bp+12h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,1
        mov     cx,[bp+10h]
        mov     es,cx
        mov     bx,word ptr[bp+0eh]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry

        .if AsyncOverride==0
                mov     dx,1
                mov     cx,[bp+0ch]
                mov     es,cx
                mov     bx,word ptr[bp+0ah]
                mov     bx,word ptr es:[bx+02h]
                mov     ax,30h
                call    WSOCKXSEntry
        .else        
                xor     dx,dx
                mov     cx,[bp+0ch]
                mov     bx,[bp+0ah]
                mov     ax,30h
                call    WSOCKXSEntry
        .endif

        xor     dx,dx
        mov     cx,[bp+08h]
        mov     bx,[bp+06h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,12
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif
mov     AsyncOverride,0

LEAVESTACK 14h

WSAAsyncGetHostByName   ENDP


PUBLIC          WSAAsyncGetProtoByNumber
WSAAsyncGetProtoByNumber        PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     bl,AsyncOverride
        mov     dx,29
        db      0c4h,0c4h,58h,2
.else
        push    cx
        xor     dx,dx
        mov     cx,[bp+18h]
        mov     bx,[bp+16h]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+14h]
        mov     bx,[bp+12h]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+10h]
        mov     bx,[bp+0eh]
        mov     ax,30h
        call    WSOCKXSEntry

        .if AsyncOverride==0
                mov     dx,1
                mov     cx,[bp+0ch]
                mov     es,cx
                mov     bx,word ptr[bp+0ah]
                mov     bx,word ptr es:[bx+02h]
                mov     ax,30h
                call    WSOCKXSEntry
        .else        
                xor     dx,dx
                mov     cx,[bp+0ch]
                mov     bx,[bp+0ah]
                mov     ax,30h
                call    WSOCKXSEntry
        .endif

        xor     dx,dx
        mov     cx,[bp+08h]
        mov     bx,[bp+06h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,13
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif
mov     AsyncOverride,0

LEAVESTACK 14h

WSAAsyncGetProtoByNumber        ENDP 


PUBLIC          WSAAsyncGetProtoByName
WSAAsyncGetProtoByName  PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     bl,AsyncOverride
        mov     dx,30
        db      0c4h,0c4h,58h,2
.else
        push    cx
        xor     dx,dx
        mov     cx,[bp+18h]
        mov     bx,[bp+16h]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+14h]
        mov     bx,[bp+12h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,1
        mov     cx,[bp+10h]
        mov     es,cx
        mov     bx,word ptr[bp+0eh]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry

        .if AsyncOverride==0
                mov     dx,1
                mov     cx,[bp+0ch]
                mov     es,cx
                mov     bx,word ptr[bp+0ah]
                mov     bx,word ptr es:[bx+02h]
                mov     ax,30h
                call    WSOCKXSEntry
        .else        
                xor     dx,dx
                mov     cx,[bp+0ch]
                mov     bx,[bp+0ah]
                mov     ax,30h
                call    WSOCKXSEntry
        .endif

        xor     dx,dx
        mov     cx,[bp+08h]
        mov     bx,[bp+06h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,14
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif
mov     AsyncOverride,0

LEAVESTACK 14h

WSAAsyncGetProtoByName  ENDP


PUBLIC          WSAAsyncGetServByPort
WSAAsyncGetServByPort   PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     bl,AsyncOverride
        mov     dx,31
        db      0c4h,0c4h,58h,2
.else
        push    cx
        xor     dx,dx
        mov     cx,[bp+1ch]
        mov     bx,[bp+1ah]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+18h]
        mov     bx,[bp+16h]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+14h]
        mov     bx,[bp+12h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,1
        mov     cx,[bp+10h]
        mov     es,cx
        mov     bx,word ptr[bp+0eh]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry

        .if AsyncOverride==0
                mov     dx,1
                mov     cx,[bp+0ch]
                mov     es,cx
                mov     bx,word ptr[bp+0ah]
                mov     bx,word ptr es:[bx+02h]
                mov     ax,30h
                call    WSOCKXSEntry
        .else        
                xor     dx,dx
                mov     cx,[bp+0ch]
                mov     bx,[bp+0ah]
                mov     ax,30h
                call    WSOCKXSEntry
        .endif

        xor     dx,dx
        mov     cx,[bp+08h]
        mov     bx,[bp+06h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,15
        mov     ax,31h
        call    WSOCKXSEntry        
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif
mov     AsyncOverride,0

LEAVESTACK 18h

WSAAsyncGetServByPort   ENDP


PUBLIC          WSAAsyncGetServByName
WSAAsyncGetServByName   PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     bl,AsyncOverride
        mov     dx,32
        db      0c4h,0c4h,58h,2
.else
        push    cx
        xor     dx,dx
        mov     cx,[bp+1ch]
        mov     bx,[bp+1ah]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+18h]
        mov     bx,[bp+16h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,1
        mov     cx,[bp+14h]
        mov     es,cx
        mov     bx,word ptr[bp+12h]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,1
        mov     cx,[bp+10h]
        mov     es,cx
        mov     bx,word ptr[bp+0eh]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry

        .if AsyncOverride==0
                mov     dx,1
                mov     cx,[bp+0ch]
                mov     es,cx
                mov     bx,word ptr[bp+0ah]
                mov     bx,word ptr es:[bx+02h]
                mov     ax,30h
                call    WSOCKXSEntry
        .else        
                xor     dx,dx
                mov     cx,[bp+0ch]
                mov     bx,[bp+0ah]
                mov     ax,30h
                call    WSOCKXSEntry
        .endif

        xor     dx,dx
        mov     cx,[bp+08h]
        mov     bx,[bp+06h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,16
        mov     ax,31h
        call    WSOCKXSEntry        
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif
mov     AsyncOverride,0

LEAVESTACK 18h

WSAAsyncGetServByName   ENDP


PUBLIC          WSACancelAsyncRequest
WSACancelAsyncRequest   PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,33
        db      0c4h,0c4h,58h,2
.else
        push    cx
        xor     dx,dx
        mov     cx,[bp+08h]
        mov     bx,[bp+06h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,17
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif

LEAVESTACK 04h

WSACancelAsyncRequest   ENDP


PUBLIC          getshortname
getshortname    PROC FAR

; Returns 8.3 filename for long filename
; No initialising stuff needed since DS not needed
push    bp
mov     bp,sp
push    bx
push    cx
push    ds
push    si
push    es
push    di
push    dx

mov     ax,word ptr[bp+0ch]
mov     ds,ax
mov     ax,word ptr[bp+08h]
mov     es,ax
mov     ax,7160h
mov     cx,0001h
mov     bx,word ptr[bp+0ah]
mov     si,word ptr[bx+02h]
push    ds
pop     es
mov     bx,word ptr[bp+06h]
mov     di,word ptr[bx+02h]
int     21h
jnc     NoFilenameError
mov     cx,0ffffh
jmp     FilenameError

NoFilenameError:
xor     cx,cx

FilenameError:
mov     dx,word ptr[bp+10h]
mov     es,dx
mov     bx,word ptr[bp+0eh]
mov     es:[bx],ax
not     cx
mov     ax,cx

pop     dx
pop     di
pop     es
pop     si
pop     ds
pop     cx
pop     bx
pop     bp
retf    0ch

getshortname    ENDP


PUBLIC          gethostname
gethostname     PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,26
        db      0c4h,0c4h,58h,2
.else
        push    cx
        mov     dx,2
        mov     cx,[bp+0ch]
        mov     es,cx
        mov     bx,word ptr[bp+0ah]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,30h
        call    WSOCKXSEntry
        xor     dx,dx
        mov     cx,[bp+08h]
        mov     bx,[bp+06h]
        mov     ax,30h
        call    WSOCKXSEntry
        mov     dx,10
        mov     ax,31h
        call    WSOCKXSEntry
        mov     RealErrorResponse,1
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
        pop     cx
.endif

LEAVESTACK 08h

gethostname     ENDP


PUBLIC          WSAAsyncSelect
WSAAsyncSelect  PROC FAR

ENTERSTACK

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,37
        db      0c4h,0c4h,58h,2
.else
        call    ZeroBuffer
        COPY    dword ptr[bp+12h],dword ptr[WSOCK2CallBuffer+00h]
        COPY    dword ptr[bp+0eh],dword ptr[WSOCK2CallBuffer+04h]
        COPY    dword ptr[bp+0ah],dword ptr[WSOCK2CallBuffer+08h]
        COPY    dword ptr[bp+06h],dword ptr[WSOCK2CallBuffer+0ch]

        push    ds
        pop     es
        mov     bx,offset WSOCK2CallBuffer
        mov     ax,10ch
        call    WSOCK2Entry
        or      ax,ax
        jnz     AsyncSelectError
        xor     ax,ax
        mov     dx,ax
        jmp     AsyncSelectEND

AsyncSelectError:
        mov     RealErrorResponse,0
        mov     LastError,ax
        mov     ax,0ffffh
        mov     dx,ax

AsyncSelectEND:
.endif

LEAVESTACK 10h

WSAAsyncSelect  ENDP


PUBLIC          WSAGetLastError
WSAGetLastError PROC FAR

push    ds
mov     ax,DSEG
mov     ds,ax

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,38
        db      0c4h,0c4h,58h,2        
.else
        cmp     RealErrorResponse,1
        je      CallWSDLL
        mov     ax,LastError
        xor     dx,dx
        pop     ds
        retf

CallWSDLL:
        mov     dx,3
        mov     ax,31h
        call    WSOCKXSEntry
        call    WaitForStatusByte2
        mov     ax,10h
        call    WSOCKXSEntry
.endif

pop     ds
retf

WSAGetLastError ENDP


; TIMER FUNCTIONS:
; Timer functions are functions designed to be used like a stopwatch,
; to measure ping times and such. I implemented them because QBasic
; lacks an accurate timer. Qbasic maintains a timer frequency of about
; one 18th of a second, while these functions have a accuracy down to
; the millisecond (1/1000th of a second).


PUBLIC          StartTimer
StartTimer      PROC FAR

push    ax
push    dx
push    ds
mov     ax,DSEG
mov     ds,ax

cmp     byte ptr[TimerRunning],01h
je      TimerAlreadyStarted

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,40
        db      0c4h,0c4h,58h,2
.else
        mov     ax,0400h
        call    WSOCKXSEntry
.endif

mov     word ptr[TimerOffset+00h],ax
mov     word ptr[TimerOffset+02h],dx

mov     byte ptr[TimerRunning],01h

TimerAlreadyStarted:
pop     ds
pop     dx
pop     ax
retf

StartTimer      ENDP


PUBLIC          StopTimer
StopTimer       PROC FAR

push    ax
push    dx
push    ds
mov     ax,DSEG
mov     ds,ax

cmp     byte ptr[TimerRunning],00h
je      TimerAlreadyStopped

call    GetTimer
mov     word ptr[TimerValue+00h],ax
mov     word ptr[TimerValue+02h],dx

mov     byte ptr[TimerRunning],00h

TimerAlreadyStopped:

pop     ds
pop     dx
pop     ax
retf

StopTimer       ENDP


PUBLIC          GetTimer
GetTimer        PROC FAR

push    ds
mov     ax,DSEG
mov     ds,ax

cmp     byte ptr[TimerRunning],00h
je      TimerStopped

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,40
        db      0c4h,0c4h,58h,2        
.else
        mov     ax,0400h
        call    WSOCKXSEntry
.endif

sub     ax,word ptr[TimerOffset+00h]
sbb     dx,word ptr[TimerOffset+02h]
add     ax,word ptr[TimerValue+00h]
adc     dx,word ptr[TimerValue+02h]
pop     ds
retf

TimerStopped:
mov     ax,word ptr[TimerValue+00h]
mov     dx,word ptr[TimerValue+02h]
pop     ds
retf

GetTimer        ENDP


PUBLIC          ResetTimer
ResetTimer      PROC FAR

push    ax
push    dx
push    ds
mov     ax,DSEG
mov     ds,ax

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,40
        db      0c4h,0c4h,58h,2        
.else        
        mov     ax,0400h
        call    WSOCKXSEntry
.endif

mov     TimerValue,0
mov     word ptr[TimerOffset+00h],ax
mov     word ptr[TimerOffset+02h],dx  

pop     ds
pop     dx
pop     ax
retf

ResetTimer      ENDP


; MISCELLANEOUS FUNCTIONS:


PUBLIC          LinMemAlloc
LinMemAlloc     PROC FAR

push    ds
mov     ax,DSEG
mov     ds,ax

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,34
        db      0c4h,0c4h,58h,2        
.else
        mov     ax,33h
        call    WSOCKXSEntry
.endif

pop     ds
retf

LinMemAlloc     ENDP


PUBLIC          LinMemFree
LinMemFree      PROC FAR

ENTERSTACK
push    ax
push    dx

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,35
        db      0c4h,0c4h,58h,2        
.else
        push    cx
        mov     cx,[bp+08h]
        mov     bx,[bp+06h]
        mov     ax,34h
        call    WSOCKXSEntry
        pop     cx
.endif

pop     dx
pop     ax
LEAVESTACK 04h

LinMemFree      ENDP


PUBLIC          LinMemCopy
LinMemCopy      PROC FAR

ENTERSTACK
push    ax
push    dx

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,36
        db      0c4h,0c4h,58h,2        
.else
        push    cx
        mov     dx,[bp+0ch]
        mov     cx,[bp+0ah]
        mov     ax,[bp+08h]
        mov     es,ax
        mov     bx,word ptr[bp+06h]
        mov     bx,word ptr es:[bx+02h]
        mov     ax,35h
        call    WSOCKXSEntry
        pop     cx
.endif

pop     dx
pop     ax
LEAVESTACK 08h

LinMemCopy      ENDP


PUBLIC          UseLinAsyncBuffer
UseLinAsyncBuffer       PROC FAR

push    ax
push    ds
mov     ax,DSEG
mov     ds,ax
mov     AsyncOverride,1
pop     ds
pop     ax
retf

UseLinAsyncBuffer       ENDP


PUBLIC          SUB32
SUB32           PROC FAR

ENTERSTACK
push    cx
mov     cx,[bp+08h]
mov     bx,[bp+06h]
mov     dx,[bp+0ch]
mov     ax,[bp+0ah]
sub     ax,bx
sbb     dx,cx
pop     cx
LEAVESTACK 08h

SUB32           ENDP


PUBLIC          AsyncResolveName
AsyncResolveName        PROC FAR

ENTERSTACK
push    ax
push    dx
push    cx
call    UseLinAsyncBuffer
call    LinMemAlloc
mov     cx,[bp+0ch]
mov     es,cx
mov     bx,[bp+0ah]
mov     es:[bx],ax
mov     es:[bx+02h],dx
push    dword ptr[bp+16h]
push    dword ptr[bp+12h]
push    dword ptr[bp+1ah]
push    dx
push    ax
push    dword ptr 1024
call    WSAAsyncGetHostByName
mov     cx,[bp+10h]
mov     es,cx
mov     bx,[bp+0eh]
mov     es:[bx],ax
mov     es:[bx+02h],dx
mov     cx,[bp+08h]
mov     es,cx
mov     bx,[bp+06h]
or      ax,ax
jnz     NoAsyncResolveError
or      dx,dx
jnz     NoAsyncResolveError

; An error occured
call    WSAGetLastError
mov     es:[bx],ax
mov     es:[bx+02h],dx
jmp     AsyncResolveNameEnd

NoAsyncResolveError:
; No error occured
xor     ax,ax
mov     es:[bx],ax
mov     es:[bx+02h],ax

AsyncResolveNameEnd:
pop     cx
pop     dx
pop     ax
LEAVESTACK 18h

AsyncResolveName        ENDP


PUBLIC          AsyncResolveAddr
AsyncResolveAddr        PROC FAR

ENTERSTACK
push    ax
push    dx
push    cx
call    UseLinAsyncBuffer
call    LinMemAlloc
mov     cx,[bp+0ch]
mov     es,cx
mov     bx,[bp+0ah]
mov     es:[bx],ax
mov     es:[bx+02h],dx
push    dword ptr[bp+16h]
push    dword ptr[bp+12h]
push    dword ptr[bp+22h]
push    dword ptr[bp+1eh]
push    dword ptr[bp+1ah]
push    dx
push    ax
push    dword ptr 1024
call    WSAAsyncGetHostByAddr
mov     cx,[bp+10h]
mov     es,cx
mov     bx,[bp+0eh]
mov     es:[bx],ax
mov     es:[bx+02h],dx
mov     cx,[bp+08h]
mov     es,cx
mov     bx,[bp+06h]
or      ax,ax
jnz     NoAsyncResolveError2
or      dx,dx
jnz     NoAsyncResolveError2

; An error occured
call    WSAGetLastError
mov     es:[bx],ax
mov     es:[bx+02h],dx
jmp     AsyncResolveAddrEnd

NoAsyncResolveError2:
; No error occured
xor     ax,ax
mov     es:[bx],ax
mov     es:[bx+02h],ax

AsyncResolveAddrEnd:
pop     cx
pop     dx
pop     ax
LEAVESTACK 20h

AsyncResolveAddr        ENDP


PUBLIC          CancelResolve
CancelResolve           PROC FAR

ENTERSTACK
push    ax
push    dx
push    dword ptr[bp+0ah]
call    WSACancelAsyncRequest
push    dword ptr[bp+06h]
call    LinMemFree
pop     dx
pop     ax
LEAVESTACK 08h

CancelResolve           ENDP


PUBLIC          PEEK32
PEEK32          PROC FAR

ENTERSTACK
push    dx

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,39
        db      0c4h,0c4h,58h,2
.else
TryAgain:
        mov     bx,word ptr[bp+06h]
        push    word ptr[bp+08h]
        pop     es
        mov     ax,1000h
        call    WSOCKXSEntry
        cmp     dx,0ffffh
        je      TryAgain
        push    ax
        mov     ax,10h
        call    WSOCKXSEntry ; Need to do this to reset things
        pop     ax
.endif

pop     dx
LEAVESTACK 04h

PEEK32          ENDP


PUBLIC          GetHWnd
GetHWnd         PROC FAR

push    ds
mov     ax,DSEG
mov     ds,ax

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,41
        db      0c4h,0c4h,58h,2
.else
        mov     ax,01h
        call    WSOCKXSEntry
.endif

pop     ds
retf

GetHWnd         ENDP


PUBLIC          GetMessage
GetMessage      PROC FAR

ENTERSTACK
push    dx

.if UseVdd==1        
        mov     ax,VddHandle
        xor     dx,dx
        db      0c4h,0c4h,58h,2
.else
        mov     ax,[bp+08h]
        mov     es,ax
        mov     bx,[bp+06h]
        mov     ax,05h
        call    WSOCKXSEntry
.endif

pop     dx
LEAVESTACK 04h

GetMessage      ENDP


PUBLIC          EnableMessage
EnableMessage   PROC FAR

push    ax
push    dx
push    ds
mov     ax,DSEG
mov     ds,ax

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,43
        db      0c4h,0c4h,58h,2
.else
        mov     ax,03h
        call    WSOCKXSEntry
.endif

pop     ds
pop     dx
pop     ax
retf

EnableMessage   ENDP


PUBLIC          DisableMessage
DisableMessage  PROC FAR

push    ax
push    dx
push    ds
mov     ax,DSEG
mov     ds,ax

.if UseVdd==1
        mov     ax,VddHandle
        mov     dx,44
        db      0c4h,0c4h,58h,2
.else
        mov     ax,04h
        call    WSOCKXSEntry
.endif

pop     ds
pop     dx
pop     ax
retf

DisableMessage  ENDP


PUBLIC          SocketHandle
SocketHandle    PROC FAR

push    ds
mov     ax,DSEG
mov     ds,ax
mov     ax,word ptr[LastSocketHandle+00h]
mov     dx,word ptr[LastSocketHandle+02h]
pop     ds
retf

SocketHandle    ENDP


PUBLIC          STRPTR
STRPTR          PROC FAR

push    bp
mov     bp,sp
xor     ax,ax
mov     dx,word ptr[bp+06h]
pop     bp
retf    02h

STRPTR          ENDP


PUBLIC          GetHigh16
GetHigh16       PROC FAR

push    bp
mov     bp,sp
mov     ax,word ptr[bp+08h]
pop     bp
retf    04h

GetHigh16       ENDP


PUBLIC          GetLow16
GetLow16        PROC FAR

push    bp
mov     bp,sp
mov     ax,word ptr[bp+06h]
pop     bp
retf    04h

GetLow16        ENDP


PUBLIC          SelfDestruct
SelfDestruct    PROC FAR

push    ax
push    dx
push    ds
mov     ax,DSEG
mov     ds,ax

.if UseVdd==1
        .if DllLoaded==0ffh
                mov     ax,VddHandle
                mov     dx,45
                db      0c4h,0c4h,58h,2                
                mov     ax,VddHandle
                db      0c4h,0c4h,58h,1 ; UnRegister module
                mov     InitSuccess,0
                mov     DllLoaded,0
        .endif
.else
        mov     ax,0fffeh
        call    WSOCKXSEntry
.endif

pop     ds
pop     dx
pop     ax
retf

SelfDestruct    ENDP


WaitForStatusByte2      PROC FAR

mov     ax,11h
call    WSOCKXSEntry
or      ax,ax
jz      WaitForStatusByte2
ret

WaitForStatusByte2      ENDP


DoBlock         PROC FAR

; Simply blocks until IOSignal returns non-zero
cmp     dword ptr[IOSignal+00h],0
jnz     SomethingHappened
jmp     DoBlock

SomethingHappened:
mov     ax,word ptr[IOReturnValue]
mov     word ptr[IOReturnValue],0
mov     dword ptr[IOSignal+00h],0
retf

DoBlock         ENDP


ZeroBuffer      PROC FAR

; This little routine will set all the values in WSOCK2CallBuffer to 0.
; It is used because a lot of functions pass about 10 NULLS to WSOCK2.VXD.
; Expects DS to point to DSEG

push    cx
mov     cx,16
mov     bx,offset WSOCK2CallBuffer
xor     eax,eax

ZeroBufferLoop:
mov     [bx],eax
add     bx,4
loop    ZeroBufferLoop
pop     cx
ret

ZeroBuffer      ENDP


CSEG            ENDS





END
