; Source code for WSOCKXS.VXD. I cannot remember exactly where I got the
; original template for the VxD (I think it was one of Iczelion's
; tutorials).

; To compile this you would require VMM.INC, VWIN32.INC and SHELL.INC. They
; are included in the windows 98 DDK.



.386p
include vmm.inc 
include vwin32.inc 
include shell.inc



DECLARE_VIRTUAL_DEVICE WSOCKXS,1,0,WSOCKXS_Control,UNDEFINED_DEVICE_ID,UNDEFINED_INIT_ORDER,DosProc,DosProc



Begin_control_dispatch WSOCKXS
        Control_Dispatch w32_DeviceIoControl,OnDeviceIoControl 
End_control_dispatch WSOCKXS 



VxD_LOCKED_DATA_SEG 

        IsByteEnabled   dw      0
        IsHWndValid     dw      0
        HWnd            dd      0
        
        ThreadID        dd      0
        MemoryBlock     dd      0
        CurrentMessage  dd      0 ; Offset into MessageBlock
        MessageOffset   dd      0 ; Also offset into MessageBlock
        MessageBlock    dd      0 ; Custom message queue

        CallFunction    dd      0000ffffh
        CallOffset      dd      0
        CallParameters  dd      8 DUP (0)

        WaitingPage     dd      0
        PageOffset      dd      0 ; This is an offset into the GlobalPages
                                  ; buffer, not a page offset
        GlobalPages     dd      8 DUP (0)

        ProcResult      dd      0
        FunctionDone    db      0
        StopPokingMe    db      0

        WSOCKNAME       db      'WSOCK2   ',0
        WSOCKCtl        dd      0
        FakeBuffer      DIOCParams      <>

VxD_LOCKED_DATA_ENDS



VxD_LOCKED_CODE_SEG 

BeginProc OnDeviceIoControl

        assume esi:ptr DIOCParams
        .if [esi].dwIoControlCode==DIOC_Open 

                VMMCall _PageAllocate, <1,PG_SYS,0,0,0,100000h,0,PAGELOCKED OR PAGEZEROINIT>
                ; SNOZZBERRY check for errors here mate
                mov MemoryBlock,eax
                VMMCall _PageAllocate, <1,PG_SYS,0,0,0,100000h,0,PAGELOCKED OR PAGEZEROINIT>
                ; SNOZZBERRY you should also check for errors here mate
                mov MessageOffset,0
                mov MessageBlock,eax
                xor eax,eax

        .elseif [esi].dwIoControlCode==DIOC_CloseHandle

                VMMCall _PageFree, <MemoryBlock,0>
                VMMCall _PageFree, <MessageBlock,0>
                xor eax,eax

        .elseif [esi].dwIoControlCode==1
        
                ; This control code is the win32 application telling us the
                ; handle to it's window.                
                
                mov eax,[esi].lpvInBuffer
                mov ecx,[eax]
                mov HWnd,ecx
                mov IsHWndValid,0ffffh
                xor eax,eax

        .elseif [esi].dwIoControlCode==2

                ; This control code is the win32 application telling us that
                ; a message (higher than 0x401 and lower than 0x1000) has
                ; arrived and it wishes to put it into our custom queue
                ; since it is not good to leave 20 messages in the windows
                ; message queue
                
                .if IsByteEnabled==1 ; Check if 16-bit client has enabled
                                     ; message handling
                        
                        mov esi,[esi].lpvInBuffer
                        mov edi,MessageBlock
                        add edi,MessageOffset
                        mov ecx,4
                        rep movsd
                        add MessageOffset,16
                        and MessageOffset,0fffh ; "Wrap-around"

                .endif

                xor eax,eax

        .elseif [esi].dwIoControlCode==3

                ; Fill partial record

                ; lpvInBuffer contains structure:
                ; Linear address        DWORD
                ; Global alias          DWORD
                ; Type                  WORD
                ; Message               WORD
                ; AsyncTaskHandle       DWORD

                mov esi,[esi].lpvInBuffer
                mov ebx,dword ptr[esi+04h]
                and ebx,0fffff000h
                mov edx,1
                mov cx,2                
                push esi
                call SearchRecord
                mov ebx,esi
                pop esi
                .if ebx!=-1
                        mov eax,dword ptr[esi+0ch]
                        mov dword ptr[ebx+0ch],eax
                        mov word ptr[ebx+08h],3
                .endif

        .elseif [esi].dwIoControlCode==4

                ; Clear full record

                ; lpvInBuffer contains structure:
                ; Linear address        DWORD
                ; Global alias          DWORD                

                mov esi,[esi].lpvInBuffer
                mov eax,dword ptr[esi]
                mov ebx,dword ptr[esi+04h]
                and ebx,0fffff000h
                mov ecx,1
                xor edx,edx
                call DeallocateRecord

        .elseif [esi].dwIoControlCode==5

                ; Set thread ID (and return call buffer location)

                VMMCall Get_Cur_Thread_Handle
                mov ThreadID,edi
                mov ebx,[esi].lpvOutBuffer
                mov [ebx],OFFSET32 CallOffset

        .elseif [esi].dwIoControlCode==6

                ; A "return byte" call was issued to service a waiting page
                ; and the current thread is now the win32 app thread.               

                ; Unlock next page
                mov eax,PageOffset
                mov ecx,[OFFSET32 GlobalPages+4+eax]
                shr ecx,12
                .if ecx!=0
                        VMMCall _LinPageUnLock, <ecx,1,PAGEMAPGLOBAL>
                .endif

                ; Replace it with WaitingPage
                mov eax,WaitingPage
                shr eax,12
                VMMCall _LinPageLock, <eax,1,PAGEMAPGLOBAL>
                mov ebx,PageOffset
                mov [OFFSET32 GlobalPages+4+ebx],eax
                mov eax,WaitingPage
                mov [OFFSET32 GlobalPages+ebx],eax
                mov WaitingPage,0
                add PageOffset,08h
                and PageOffset,1fh

        .elseif [esi].dwIoControlCode==7

                ; Function has completed and DLL is wants to return the
                ; return value returned by the called function

                ; lpvInBuffer contains structure:
                ; Return value          DWORD

                mov esi,[esi].lpvInBuffer
                mov eax,dword ptr[esi]
                mov ProcResult,eax
                mov FunctionDone,0ffh

        .elseif [esi].dwIoControlCode==8

                ; Get function number. This will only return valid once
                ; until the function completes. This is to ensure that
                ; multiple QueueUserApc calls don't result in multiple
                ; function calls.
                ; Also stops the repeated QueueUserApc calls (in other words,
                ; it is a notification of the call)

                mov esi,[esi].lpvOutBuffer
                mov eax,CallFunction
                mov dword ptr[esi],eax
                mov CallFunction,0000ffffh
                mov StopPokingMe,0ffh

        .elseif [esi].dwIoControlCode==9

                ; Clear filled partial record

                ; lpvInBuffer contains structure:
                ; Linear address        DWORD
                ; Global alias          DWORD
                ; Type                  WORD
                ; Message               WORD
                ; AsyncTaskHandle       DWORD
                ; We only need AsyncTaskHandle, since this will be a
                ; unique number

                mov esi,[esi].lpvInBuffer
                mov edx,dword ptr[esi+0ch] ; EDX = AsyncTaskHandle
                xor eax,eax                ; EAX = Linear address (not needed)
                xor ebx,ebx                ; EBX = Global alias (not needed)
                mov ecx,3                  ; ECX = Message:Type
                call DeallocateRecord

        .elseif [esi].dwIoControlCode==10

                ; Clear partial record

                ; lpvInBuffer contains structure:
                ; Linear address        DWORD
                ; Global alias          DWORD

                mov esi,[esi].lpvInBuffer
                mov eax,dword ptr[esi]
                mov ebx,dword ptr[esi+04h]
                and ebx,0fffff000h
                mov ecx,2
                xor edx,edx
                call DeallocateRecord

        .endif
        ret

EndProc OnDeviceIoControl 

BeginProc DosProc

        assume ebp:ptr Client_Reg_Struc
        push eax
        push ebx

        ; On entry AX contains a function number, and depending on the
        ; function being called, ES, BX and/or DX may be used. Usually
        ; a return value is returned in AX or DX:AX (for 32-bit values).

        .if [ebp].Client_AX==1

                ; Client wishes to know the win32 application's window
                ; handle. Hopefully on loading the win32 application should
                ; have notified the VxD what it's handle was.

                mov ax,word ptr[HWnd]
                mov [ebp.Client_AX],ax
                mov ax,word ptr[HWnd+02]
                mov [ebp.Client_DX],ax

        .elseif [ebp].Client_AX==3

                ; Client wants to enable message handling.

                mov IsByteEnabled,1

        .elseif [ebp].Client_AX==4

                ; Client wants to disable message handling.

                mov IsByteEnabled,0
                mov eax,MessageOffset
                mov CurrentMessage,eax ; Clear all messages

        .elseif [ebp].Client_AX==5

                ; Client wants to copy a message into a buffer. If there is
                ; no message it returns 0, otherwise returns -1
                ; Copies oldest message recieved (16 bytes) into ES:BX
                
                mov eax,CurrentMessage

                .if MessageOffset!=eax
                        Client_Ptr_Flat EDI, ES, BX
                        mov esi,MessageBlock
                        add esi,CurrentMessage
                        mov ecx,4
                        rep movsd
                        add CurrentMessage,16
                        and CurrentMessage,0fffh ; "Wrap-around"
                        mov ax,0ffffh
                        mov [ebp].Client_AX,ax
                        mov [ebp].Client_DX,ax
                .else
                        xor ax,ax
                        mov [ebp].Client_AX,ax
                        mov [ebp].Client_DX,ax
                .endif

        .elseif [ebp].Client_AX==0109h

                ; Use a "wrapped" versioin of WSOCK2.VXD's "recv" call. The
                ; original WSOCK2.VXD call mistakenly translates 4 addresses
                ; when only 3 need to be. This results in the socket handle
                ; parameter being corrupted. This routine translates the
                ; addresses manually and "fakes" a call to WSOCK2.VXD's
                ; DeviceIoControl procedure.

                mov ecx,3     ; Number of addresses to be translated.
                call TranslateAddresses
                mov eax,0109h ; Function number
                mov ecx,34h   ; Number of bytes in buffer
                call Wsock2Function

        .elseif [ebp].Client_AX==010Dh

                ; Same as the above, except that this case is the "send"
                ; call. WSOCK2.VXD translates 3 addresses when it only needs
                ; to translate 2 of them.

                mov ecx,2     ; Number of addresses to be translated.
                call TranslateAddresses
                mov eax,010dh ; Function number
                mov ecx,34h   ; Number of bytes in buffer
                call Wsock2Function

        .elseif [ebp].Client_AX==10h

                ; Returns result of last called DLL function in DX:AX. This
                ; is used so the 16-bit client can get a return value.
                ; This signifies a completion in the entire call DLL function
                ; sequence, so we can reset StopPokingMe

                mov FunctionDone,0
                mov StopPokingMe,0
                mov ax,word ptr[ProcResult]
                mov [ebp.Client_AX],ax
                mov ax,word ptr[ProcResult+02]
                mov [ebp.Client_DX],ax
       
        .elseif [ebp].Client_AX==11h

                ; Client wishes to check completion of DLL function.
                ; Returns 0 in AX if not complete, non-zero otherwise

                mov eax,-1
                call CallWin32
                .if FunctionDone==0ffh
                        mov [ebp].Client_AX,0ffffh
                .else
                        mov [ebp].Client_AX,0
                .endif

        .elseif [ebp].Client_AX==1000h

                ; Get byte from linear address at ES:BX
                ; Returns it in AL. If DX = 0FFFFh then you will have to
                ; wait. Eventually DX will not be 0FFFFh and it will be 0,
                ; then AL will contain the byte.

                mov ecx,4
                mov ax,[ebp].Client_ES
                shl eax,16
                mov ax,[ebp].Client_BX
                mov edx,eax
                and eax,0fffff000h ; -> Page
                and edx,000000fffh ; -> offset
                mov ebx,offset GlobalPages
        FindPageLoop:
                cmp [ebx],eax
                je PageFound
                add ebx,08h
                loop FindPageLoop

                ; Otherwise it wasn't found and we need to request it by
                ; putting it on the "waiting list" (if it wasn't already
                ; there)
                mov [ebp].Client_DX,0ffffh
                .if WaitingPage!=eax
                        mov WaitingPage,eax

                        ; Issue a call to the win32 app to switch threads
                        mov eax,0
                        call CallWin32
                .else
                        mov eax,-1
                        call CallWin32                        
                .endif

                jmp SkipCode

        PageFound:
                mov ebx,[ebx+04h]
                add ebx,edx ; Add offset to global page alias
                xor ax,ax
                mov al,[ebx]
                mov [ebp].Client_AX,ax
                mov [ebp].Client_DX,0
        SkipCode:

        .elseif [ebp].Client_AX==0FFFEh

                ; Post WM_DESTROY message to close program. The program will
                ; actually unload this VxD, so this VxD will also be
                ; unloaded.
               
                VxDCall _SHELL_PostMessage, <HWnd,00080002h,0,0,0,0>
       
        .elseif [ebp].Client_AX==24h

                ; Tests whether win32 application has given its handle yet.
                ; This stops a bug where the win32 app would be pre-empted
                ; and the dos box would either call "GetHWnd" or
                ; "SelfDestruct" before any window handle was given.
                ; Returns 0ffffh in AX if handle is valid
                ; Returns zero in AX if handle is invalid

                mov ax,IsHWndValid
                mov [ebp.Client_AX],ax

        .elseif [ebp].Client_AX==0400h

                ; Returns system time in DX:AX

                VMMCall Get_System_Time
                mov [ebp.Client_AX],ax
                shr eax,16
                mov [ebp.Client_DX],ax
       
        .elseif [ebp].Client_AX==30h

                ; Insert parameter

                ; CX:BX contains value to add
                ; If DX = 0 then insert value
                ; If DX = 1 then make partial record
                ; If DX = 2 then make full record

                .if [ebp].Client_DX==0

                        mov dx,[ebp].Client_CX
                        shl edx,16
                        mov dx,[ebp].Client_BX
                        call AddParameter

                .elseif [ebp].Client_DX==1

                        ; Note: Client_DX contains message
                        Client_Ptr_Flat EAX, CX, BX
                        mov edx,eax
                        and edx,000000fffh
                        and eax,0fffff000h
                        push edx

                        ; Search for a duplicate
                        xor edx,edx
                        call SearchRecord

                        .if esi==-1
                                ; No duplicate
                                push eax
                                shr eax,12
                                VMMCall _LinPageLock, <eax,2,PAGEMAPGLOBAL>
                                ; SNOZZBERRY check for errors here mate
                                mov ebx,eax ; EBX = Global alias
                                pop eax     ; EAX = Linear address
                        .else
                                ; Duplicate at [esi]
                                                  ; EAX is already set
                                mov ebx,dword ptr[esi+04h]
                                                  ; EBX = Global alias
                        .endif

                        mov cx,[ebp].Client_DX
                        shl ecx,16        
                        mov cx,2          ; ECX = Message:Type
                        xor edx,edx       ; EDX = AsyncHandle
                        call AllocateRecord
                        ; SNOZZBERRY check for errors here mate
                        
                        pop edx
                        add edx,ecx
                        call AddParameter

                .elseif [ebp].Client_DX==2
                        
                        Client_Ptr_Flat EAX, CX, BX
                        mov edx,eax
                        and edx,000000fffh
                        and eax,0fffff000h
                        push edx

                        ; Search for a duplicate
                        xor edx,edx
                        call SearchRecord

                        .if esi==-1
                                ; No duplicate
                                push eax
                                shr eax,12
                                VMMCall _LinPageLock, <eax,2,PAGEMAPGLOBAL>
                                ; SNOZZBERRY check for errors here mate
                                mov ebx,eax ; EBX = Global alias
                                pop eax     ; EAX = Linear address
                        .else
                                ; Duplicate at [ESI]
                                mov ebx,dword ptr[esi+04h]
                        .endif

                        mov ecx,1
                        xor edx,edx
                        call AllocateRecord
                        ; SNOZZBERRY check for errors here mate

                        pop edx
                        add edx,ecx
                        call AddParameter
                .endif
               
        .elseif [ebp].Client_AX==31h

                ; Call function
                ; DX contains function number to call

                mov CallOffset,0
                xor eax,eax
                mov ax,[ebp].Client_DX
                call CallWin32

        .elseif [ebp].Client_AX==33h

                ; Allocates a 1024-byte memory block. Actually, it allocates
                ; a page, but a page is 4096 bytes long. So it searches for
                ; a memory record that is not full and uses that. If there
                ; are no memory records, or they are all full, it creates a
                ; new one.
                ; Returns block in DX:AX

                xor edi,edi
                mov esi,MemoryBlock
        SearchLoop9:
                cmp word ptr[esi+08h],4
                jne NotSame9
                cmp dword ptr[esi+0ch],0fh ; All taken
                je NotSame9
                jmp EndLoop9
        NotSame9:
                add esi,10h
                add edi,10h
                cmp edi,1000h ; End of block
                jne SearchLoop9
        EndLoop9:
                .if edi==1000h
                        ; We have to allocate and create our own record
                        VMMCall _PageAllocate, <1,PG_SYS,0,0,0,100000h,0,PAGELOCKED OR PAGEZEROINIT>
                        ; SNOZZBERRY check for errors here
                        push eax
                        mov [ebp].Client_AX,ax
                        shr eax,16
                        mov [ebp].Client_DX,ax
                        pop eax
                        xor ebx,ebx
                        mov ecx,4
                        mov edx,1
                        call AllocateRecord
                        ; SNOZZBERRY check for errors here
                .else
                        ; We found a record with space in it at [ESI]
                        ; Find the free position
                        mov eax,dword ptr[esi]
                        mov edx,dword ptr[esi+0ch]
                        test edx,1
                        jnz TestBit1

                        ; Bit 0 has not been set
                        or edx,1
                        jmp EndTests

                TestBit1:
                        test edx,2
                        jnz TestBit2

                        ; Bit 1 has not been set
                        add eax,400h
                        or edx,2
                        jmp EndTests

                TestBit2:
                        test edx,4
                        jnz TestBit3

                        ; Bit 2 has not been set
                        add eax,800h
                        or edx,4
                        jmp EndTests

                TestBit3:
                        ; Since we know one bit wasn't set and this is the
                        ; last one, it must be free
                        add eax,0c00h
                        or edx,8
                        jmp EndTests

                EndTests:
                        ; Write the result and return EAX
                        mov dword ptr[esi+0ch],edx
                        mov [ebp].Client_AX,ax
                        shr eax,16
                        mov [ebp].Client_DX,ax

                .endif

        .elseif [ebp].Client_AX==34h

                ; Frees a 1024-byte block specified in CX:BX. Nothing is
                ; returned. If the block is the last in a page, the page
                ; is freed

                mov ax,[ebp].Client_CX
                shl eax,16
                mov ax,[ebp].Client_BX
                mov ebx,eax
                and eax,0fffff000h
                and ebx,000000fffh
                xor edx,edx
                mov ecx,4
                call SearchRecord
                .if esi!=-1                        
                        .if ebx==0
                                mov edx,0eh
                        .elseif ebx==400h
                                mov edx,0dh
                        .elseif ebx==800h
                                mov edx,0bh
                        .elseif ebx==0c00h
                                mov edx,07h
                        .endif
                        and dword ptr[esi+0ch],edx
                        jnz ZeroFlagNotSet
                        
                        ; We cleared out the last block in the page
                        VMMCall _PageFree, <eax,0>
                        xor eax,eax
                        mov dword ptr[esi],eax
                        mov dword ptr[esi+04h],eax
                        mov dword ptr[esi+08h],eax
                        mov dword ptr[esi+0ch],eax
                ZeroFlagNotSet:

                .endif

        .elseif [ebp].Client_AX==35h                

                ; Copy the buffer specified as a linear address in DX:CX
                ; into the real mode address in ES:BX
                ; Copies 1024 bytes

                mov si,[ebp].Client_DX
                shl esi,16
                mov si,[ebp].Client_CX
                Client_Ptr_Flat EDI, ES, BX
                mov ecx,100h ; 256 DWORDs
                rep movsd

        .endif

        pop ebx
        pop eax
        clc
        ret

EndProc DosProc

BeginProc TranslateAddresses

        ; Will translate ECX addresses at client's ES:BX. To do this the
        ; function saves the current values in the client reg structure,
        ; then fills the client's ES:BX with the address to be translated.
        ; The Client_Ptr_Flat macro will then be able to translate them.
        ; After that the original values of the client's ES:BX will be
        ; restored

        Client_Ptr_Flat ESI, ES, BX  ; ESI = First byte of buffer
        push word ptr[ebp].Client_BX ; Save client registers ES and BX
        push word ptr[ebp].Client_ES
        mov ebx,esi
TranslateAgain:
        ; Loop to translate addresses
        mov ax,[EBX]
        mov [ebp].Client_BX,ax ; Move addresses to translate into client
        mov ax,[EBX+02]        ; registers
        mov [ebp].Client_ES,ax

        ; Check to see its not 0 (if it's a zero don't bother translating it)
        cmp dword ptr[ebx],0
        jnz TranslateIt
        xor eax,eax
        jmp Skip2
TranslateIt:
        Client_Ptr_Flat EAX, ES, BX
Skip2:
        mov [EBX],eax ; EAX = translated address
        add ebx,4     ; EBX = linear address of address to be translated
        loop TranslateAgain

        ; Translate pointer to send buffer (only translates first one)
        mov ebx,dword ptr[esi]  
        mov ax, [EBX+04]            ; First 4 bytes is length so next 4 is
        mov [ebp].Client_BX,ax      ; the buffer
        mov ax, [EBX+06]
        mov [ebp].Client_ES,ax
        Client_Ptr_Flat EAX, ES, BX
        mov [EBX+04], eax

        pop word ptr[ebp].Client_BX
        pop word ptr[ebp].Client_ES
        ret

EndProc TranslateAddresses

BeginProc Wsock2Function

        ; Get the address of WSOCK2.VXD's control procedure, construct a
        ; fake buffer to pass to it and then call it. This is how a 32-bit
        ; application would call WSOCK2.VXD, so no addresses are translated.

        push eax
        push ecx
        mov eax,3B0Ah ; WSOCK2ID
        mov edi,OFFSET32 WSOCKNAME
        VMMCall Get_DDB
        mov edi,[ECX].DDB_Control_Proc ; Get address of WSOCK2.VXD's control
                                       ; procedure (to call)

        ; Fill fake buffer with the correct values for a DeviceIoControl call
        pop ecx
        pop eax
        mov [FakeBuffer].VMHandle,0
        mov [FakeBuffer].dwIoControlCode,eax ; Function number
        mov [FakeBuffer].lpvInBuffer,esi     ; Address of buffer
        mov [FakeBuffer].cbInBuffer,ecx      ; Length of buffer

        ; Make the fake call to WSOCK2.VXD
        mov eax,w32_DeviceIoControl
        mov esi,offset32 FakeBuffer
        call edi
        mov [EBP].Client_AX,ax
        ret

EndProc Wsock2Function

BeginProc AllocateRecord

        ; Allocates a record. On entry:
        ; EAX = Linear address
        ; EBX = Global alias of linear address
        ; ECX = Message number:Type (ie. High 16 bits are message, CX = Type)
        ; EDX = Asynchronous task handle
        ; Returns EAX = 0 if successful, non-zero if no memory left
        ; Also returns ECX = global alias specified at start
        ; Note that this will NOT lock the address in EAX
        
        push esi
        push ebx ; This later turns into ECX
        push ecx

        ; If ECX = 1 (full record) then if an identical record record exists
        ; the "AsyncHandle" field will be incremented
        .if ECX==1
                ; Search for an identical record. Note that any linear
                ; address has a unique global alias. Therefore checking
                ; of the global alias is not needed.

                xor edx,edx
                call SearchRecord
                .if esi!=-1
                        ; We have one, so just increment AsyncTaskHandle
                        ; field instead.
                        inc dword ptr[esi+0ch]
                        pop ecx
                        pop ecx
                        xor eax,eax
                        pop esi
                        ret
                .endif
        .endif

        xor ecx,ecx                        
        mov esi,MemoryBlock
SearchLoop3:
        cmp word ptr[esi+08h],0
        je EndLoop3
        add esi,10h
        add ecx,10h
        cmp ecx,1000h ; End of block
        jne SearchLoop3
EndLoop3:
        .if ecx==1000h
                ; All records are taken!
                pop ecx
                pop ecx
                pop esi
                mov eax,0ffffffffh
                ret
        .endif
        pop ecx
        ; Otherwise write record to [ESI]
        mov dword ptr[esi],eax
        mov dword ptr[esi+04h],ebx
        mov dword ptr[esi+08h],ecx
        mov dword ptr[esi+0ch],edx

        xor eax,eax ; Successful completion
        pop ecx
        pop esi
        ret

EndProc AllocateRecord

BeginProc SearchRecord

        ; Searches for a type CX record with the linear address in EAX.
        ; Searches for EBX (global alias) if EDX = 1
        ; Returns -1 in ESI if not found, otherwise ESI is a pointer to the
        ; start of the record

        xor edi,edi
        mov esi,MemoryBlock
SearchLoop:
        .if edx==1
                cmp dword ptr[esi+04h],ebx
                jne NotSame
        .else
                cmp dword ptr[esi],eax
                jne NotSame
        .endif
        cmp word ptr[esi+08h],cx
        jne NotSame
        jmp EndLoop
NotSame:
        add esi,10h
        add edi,10h
        cmp edi,1000h ; End of block
        jne SearchLoop
EndLoop:
        .if edi==1000h ; not found
                mov esi,-1
        .endif
        ret

EndProc SearchRecord

BeginProc DeallocateRecord

        ; Deallocates a record. Returns nothing. It focuses on the global
        ; alias instead of the linear address since this is how the win32
        ; application will reference it.
        ; It will unlock a page if there are no records left
        ; Note that if CX = 1 or 2 if EDX = 0 EAX will be used as reference
        ; otherwise EBX is used as reference

        ; Input parameters are the same as for AllocateRecord        

        push edi
        push esi

        .if cx==3

                ; Simply find a filled partial record with a matching
                ; AsyncHandle (EDX) and bust it

                mov esi,MemoryBlock
                xor ecx,ecx
        SearchLoop7:
                cmp dword ptr[esi+0ch],edx
                jne NotSame7
                cmp word ptr[esi+08h],3
                jne NotSame7
                jmp EndLoop7
        NotSame7:
                add esi,10h
                add ecx,10h
                cmp ecx,1000h ; End of block
                jne SearchLoop7
        EndLoop7:
                .if ecx < 1000h
                        ; Bust it
                        xor ecx,ecx
                        mov dword ptr[esi],ecx
                        mov ebx,dword ptr[esi+04h]
                        mov dword ptr[esi+04h],ecx
                        mov dword ptr[esi+08h],ecx
                        mov dword ptr[esi+0ch],ecx
                .endif

        .else

                ; Search for a the corresponding record and:
                ; For full records: Decrement it if if AsyncTaskHandle is not 
                ;                   0 and if AsyncTaskHandle field is 0,
                ;                   clear it
                ; For partial records: Clear it

                mov edx,1 ; Note that the dos box will never call this since
                          ; the dos box only cancels filled partial records
                call SearchRecord

                .if esi!=-1
                        .if cx==1                        
                                ; Decrement or destroy
                                .if dword ptr[esi+0ch]==0
                                        ; Destroy
                                        xor ecx,ecx
                                        mov dword ptr[esi],ecx
                                        mov ebx,dword ptr[esi+04h]
                                        mov dword ptr[esi+04h],ecx
                                        mov dword ptr[esi+08h],ecx
                                        mov dword ptr[esi+0ch],ecx
                                .else
                                        ; Decrement
                                        mov ebx,dword ptr[esi+04h]
                                        dec dword ptr[esi+0ch]
                                .endif                        
                        .elseif cx==2
                                ; Destroy
                                xor ecx,ecx
                                mov dword ptr[esi],ecx
                                mov ebx,dword ptr[esi+04h]
                                mov dword ptr[esi+04h],ecx
                                mov dword ptr[esi+08h],ecx
                                mov dword ptr[esi+0ch],ecx
                        .endif
                .endif
        .endif

        ; Now search for a record with the global alias of EBX. If there is
        ; none, we eliminated the last record before, and can promptly
        ; unlock it.
        xor ecx,ecx                        
        mov esi,MemoryBlock
SearchLoop5:
        cmp dword ptr[esi+04h],ebx
        je EndLoop5
        add esi,10h
        add ecx,10h
        cmp ecx,1000h ; End of block
        jne SearchLoop5
EndLoop5:
        .if ecx==1000h
                ; We eliminated the last one; there are no more
                VMMCall _LinPageUnLock, <ebx,2,PAGEMAPGLOBAL>
        .endif

        pop esi
        pop edi
        ret

EndProc DeallocateRecord

BeginProc AddParameter

        ; Adds EDX to the parameter list
        ; Destroys EBX

        .if CallOffset < 32                
                mov ebx,offset CallParameters
                add ebx,CallOffset
                mov [ebx],edx
                add CallOffset,4
        .endif
        ret

EndProc AddParameter

BeginProc CallWin32

        ; Calls the win32 application with function specified in EAX
        ; If EAX = -1 then do not use a function number

        .if StopPokingMe==0
                .if eax!=-1
                        mov CallFunction,eax
                .endif
                VxDCall _VWIN32_QueueUserApc, <0,0,ThreadID>
                mov eax,LOW_PRI_DEVICE_BOOST
                mov edi,ThreadID
                VMMCall Adjust_Thread_Exec_Priority
        .endif
        ret

EndProc CallWin32


VxD_LOCKED_CODE_ENDS


end


